{
******************************************************************************
*                                                                            *
*       CINVESTAV-IPN ING. ELECTRICA SECC. DE COMPUTACION                    *
*                                                                            *
*       COMPILADOR PARA LENGUAJE GAUSS, TOMADO DEL LIBRO :                   *
*                                                                            *
*       " AN IMPLEMENTATION GUIDE TO COMPILER WRITING "                      *
*           De Jean-Paul Tremblay & Paul G. Sorenson                         *
*                                                                            *
*       Originalmente Escrito en PL/1 y traducido a Pascal                   *
*                                                                            *
*       ASESOR        : DR. JOSEF KOLAR                                      *
*       REALIZADO POR : GUSTAVO ARROYO D.                                    *
*                                                                            *
******************************************************************************
}
{$U+}
Program Compile;
{       ************************************************************
        *                                                          *
        *                       compile                            *
        *                                                          *
        ************************************************************

        Las siguientes constantes definen el tamano de ciertas tablas
}
const
     strlen = 255 ;
     idlen  = 16 ;
     N_of_symbols = 122 ;
     N_of_terminals = 57 ;
     N_of_keywords = 26 ;
     N_of_instructions = 68 ;  (* tenia 65 *)
     forever = true;           {     forever = while ('1'b) }
     parse_limit = 250 ;
     nhash = 53 ;
     nsymtab = 200 ;
     ncode = 600 ;
     nglobal = 400;
     npinfo = 100 ;
     nsem = 100;
     nxr = 200 ;
     xrnode = 5 ;
     null = 0 ;
     nrun = 100 ;
     strsize = 200 ;
     nsize = 200 ;
spc70='                                                                      ';
spc80=
'                                                                             ';

                                                                              {
                 Las siguientes constantes son utilizadas para definir
                 las entradas a las tablas para el parser LL(1)               }

     Apop = 159 ;
     Aaccept = 160 ;
     Aerror  = 161 ;

Type
                                                                              {
                El siguiente tipo escalar es utilizado para definir los
                nombres de los tokens que seran usados en el compilador,
                en lugar de usar costantes enteras para los tokens. Cuando
                se inserte otra definicion de token, una entrada correspon -
                diente debe hacerse en en el vector 'token_str' definido en
                el procedimiento  'init'.
                Todos los tokens comenzaran con un caracter "N" asi seran
                facilmente reconocidos de los identificadores en el listado
                fuente del compilador                                         }


         token = (Nnull,Nand,Narray,Nconst,Nelse,Nendif,Nendloop,Nendproc,
                  Nfalse,Nforward,Nif,Ninteger,Nlogical,Nloop,Nnot,Nof,Nor,
                  Nproc,Nread,Nreturn,Nstring,Nstop,Nthen,Ntrue,Nusing,Nwhile,
                  Nwrite,Narrayident,Narrayconident,Nassign,Ncolon,Ncomma,
                  Nconcat,Ndiv,Neof,Neq,Nge,Ngt,Nindex,Nle,Nlength,Nliteral,
                  Nlparen,Nlt,Nminus,Nmult,Nmod,Nne,Nnewident,Nnumber,Nplus,
                  Nprocident,Nrparen,Nsemi,Nsimpident,Nsimpconident,Nsubstr,
                  Numinus,
                                                                              {
                El siguiente conjunto de definiciones son para los simbolos
                no terminales utilizados en la gramatica LL(1) para GAUSS.
                Todos comenzaran con una "S" para que puedan ser distinguidos
                facilmente en el codigo fuente
                                                                              }
                  Sprogram,Sglobal,Score,Sdeclaration_list,Sprocedure_list,
                  Sdeclaration,Sentity_list,Sconstant_list,Stype_specifier,
                  Ssimple_type,Sarray,Sbound_pair_list,Sbound_pair,
                  Ssecond_bound,Sconstant,Ssimple_constant,Sarray_constant,
                  Ssimple_constant_list,Sident_list,Sprocedure,Sprocedure_tail,
                  Sprocedure_body,Sstatement_list,Sparameter_list,Sparameters,
                  Sparameter,Sparameter_type,Scomma_list,Sstatement,
                  Sprocedure_call,Sargument_list,Sarguments,Sargument,Ssublist,
                  Sreturn_stmt,Sret_expression,Sif_stmt,Sthen_clause,
                  Selse_clause,Swhile_stmt,Sstop_stmt,Sassignment_stmt,
                  Ssubstring,Sstart,Slength,Sread_stmt,Sinput_goal_list,
                  Sinput_goals,Sinput_goal,Swrite_stmt,Sexpression_list,
                  Sexpressions,Sexpression,Setail,Spart,Sptail,Sterm,Sttail,
                  Sfactor,Sindex,Sitail,Scatena,Sctail,Sprimary,
                  Sproc_name,NN201,NN202,NN203,NN204,NN205,NN206,NN207,NN208,
                  NN209,NN210,NN211,NN212,NN213,NN214,NN215,NN216,NN217,NN218,
                  NN219,NN220,NN221,NN222,NN223,NN224,NN225,NN226,NN227,NN228,
                  NN229,NN230,NN231,NN232,NN233,NN234,NN235,NN236,NN237,NN238,
                  NN239,NN240,NN241,NN242,NN243,NN244,NN245,NN246,NN247,NN248,
                  NN249,NN250,NN251,NN252,NN253,NN254,NN255,NN256,NN257,NN258,
                  NN259,NN260,NN261,NN262,NN263,NN264,NN265,NN266,NN267,NN268,
                  NN269,NN270,NN271,NN272,NN273,NN274,NN275,NN276,NN277,NN278,
                  NN279,NN280,NN281,NN282,NN283,NN284,NN285,NN286,NN287,NN288,
                  NN289 ) ;

                                                                              {
                El siguiente tipo es declarado para definir instrucciones
                usadas en la generacion de codigo
                                                                              }
         instructions = (SSnull,SSabsolute,SSadd,SSallocate,SSconcat,SSderef,
                  SSderefi,SSdivide,SSdump,SSieq,SSige,SSigt,SSile,SSilt,SSine,
                  SSindex,SSnewline,SSjump,SSreadlog,SSload,SSloadi,SSline,
                  SSmultiply,SSnegate,SSpush,SSloada,SSrem,SSseq,SSsge,SSsgt,
                  SSsle,SSslt,SSsne,SSstore,SSstorei,SSsubtract,SSsubstring,
                  SSsubstringl,SStemplate,SSreturn,SSreturnval,SSsaveabp,
                  SSincrsp,SSand,SSnot,SSor,SSbranch,SSbranchf,SSpop,SSreplace,
                  SSreplacel,SSstop,SSstorea,SSreadint,SSreadstr,SSwrite,
                  SSwriteint,SSwritelog,SSwritestr,SSspace,SStab,SSend_of_file,
                  SSloads,SSloadsi,SSloadsa,SSlength);

         string40 = string[40];
         error_indices = array[1..15] of integer;
         indices_pat_space = array[1..58] of integer;
         token_string = array[0..N_of_symbols] of string[26];
         code_instructions = array [1..N_of_instructions] of string[25];
         num_operands = array[1..N_of_instructions] of integer;

               { Declaracion de variables de Compile }
Var     real_eof : boolean;
        eof1      : boolean ;           { senal de fin de programa           }

Procedure init;
{       ************************************************************
        *                                                          *
        *                       init                               *
        *                                                          *
        ************************************************************

        Este procedimiento es utilizado para inicializar el total de las varia-
        bles que son requeridas para que trabaje el compilador. Note que el al-
        cance de este procedimiento cubre el total de el compilador
                                                                              }

     const
                                                                              {
                La siguiente tabla es utilizada para asociar los tokens con
                sus valores. Cuando el valor del token es utilizado como un
                indice a esta tabla, la correspondiente posicion es la repre -
                sentacion del token. Esta tabla esta directamente ligada a
                los valores del tipo "token" declarado arriba. Las palabras
                reservadas del lenguaje GAUSS aparecen al principio de la
                tabla. Despues de estos vienen los simbolos de los tokens.
                Si el lenguaje es expandido, debemos mantener en mente lo si -
                guiente, cuando se agregen nuevos elementos a la tabla.
                1. Las palabras clave aparecen al principio de la tabla, con
                   sus respectivos simbolos que aparecen despues.
                2. Las macrodefiniciones, en este caso los tipos escalares,
                   para las nuevas entradas deberan ser creados, y las anti-
                   guas definiciones tendran que ser cambiadas tal que el va-
                   lor de cada token es el indice en el vector de tokens,
                   "tokens_str".
                3. Si el tamano de el vector es cambiado, las constantes de:
                   'N_of_symbols', 'N_of_keywords', y 'N_of_terminals' tendran
                   que ser cambiados, dependiendo de los cambios hechos al
                   compilador.
                                                                              }

         token_str : token_string =

                 ('','and','array','const','else','endif','endloop','endproc',
                  'false','forward','if','integer','logical','loop','not','of',
                  'or','proc','read','return','string','stop','then','true',
                  'using','while','write','array identifier',
                  'array constant identifier',':=',':',',','&','/',
                  'end-of-file','=','>=','>','@','<=','#','literal','(','<',
                  '-','*','%','<>','new identifier','number','+',
                  'procedure identifier',')',';','simple identifier',
                  'simple constant identifier','|','-','program','global',
                  'core','declaration list','procedure list','declaration',
                  'entity list','const list','type specifier','simple type',
                  'array','boud pair list','bound pair','second bound',
                  'constant','simple constant','array constant',
                  'simple constant list','ident list','procedure',
                  'procedure tail','procedure body','statment list',
                  'parameter list','parameters','parameter','parameter type',
                  'comma list','statement','procedure call','argument list',
                  'arguments','argument','sublist','return stmt',
                  'ret expression','if stmt','then clause','else clause',
                  'while stmt','stop stmt','assignment stmt','substring',
                  'start','length','read stmt','input goal list','input goals',
                  'input goal','write stmt','expression list','expressions',
                  'expression','etail','part','ptail','term','ttail','factor',
                  'index','itail','catena','ctail','primary','procedure name');

                                                                              {
                La tabla "instr_str" contiene los mnemonicos de el codigo de
                las instrucciones                                             }

         instr_str : code_instructions =
                  ('absolute','add','allocate','concatenate','dereference',
                  'dereference indirect','divide','dump','int =','int >=',
                  'int >','int <=','int <','int <>','index','newline','jump',
                  'read logical','load','load indirect','line number',
                  'multiply','negate','push','load absolute','remainder',
                  'string =','string >=','string >','string <=','string <',
                  'string <>','store','store indirect','subtract',
                  'substring until end','substring given length','template',
                  'return','return value','save act base ptr','incr stack ptr',
                  'and','not','or','branch','branch on false','pop',
                  'replace until end','replace given length','stop',
                  'store absolute','read integer','read string','start write',
                  'write integer','write logical','write string','space','tab',
                  'end of file','load string','load string indirect',
                  'load string absolute','store string',
                  'store string indirect','store string absolute','length');
                                                                              {
                "num_ops" entrega el numero de operandos asociados con cada
                instruccion                                                   }

         num_ops : num_operands =
                  (1,0,2,0,1,1,0,1,0,0,{-}0,0,0,0,0,0,2,0,1,1,
                   1,0,0,1,0,0,0,0,0,0,{-}0,0,1,1,0,0,0,2,0,0,
                   0,1,1,0,1,1,1,0,0,0,{-}0,0,0,0,1,1,0,1,1,1,
                   0,1,1,0,1,1,0,0);
                                                                              {
                La tabla "err_mesg_tab" contiene indices que apuntan a la tabla
                "pat_space", la cual dara los indices qu apuntan a la tabla
                "dict" para el correspondiente numero de error. Por ejemplo,
                para el error numero 3, "err_mesg_tab (3)" dara un indice que
                apunta a "pat_space" donde los indices a "dict" seran encontra-
                dos para generar el mensaje de error para el error numero 3
                                                                              }
         err_mesg_tab : error_indices =
                   (1,3,6,10,12,16,21,26,26,32,28,41,49,54,59);

                                                                              {
              La tabla "pat_space" contiene indices a la tabla "dict", la cual
              generara los mensajes de error apropiados. La "err_mesg_tab" es
              usada para encontrar los indices para algun numero de error dado
                                                                              }
         pat_space : array[1..58] of integer =
                   (1,2,3,4,5,6,7,8,9,10,6,11,7,8,12,19,20,
                   15,16,17,19,20,15,16,18,21,22,23,24,25,26,
                   27,22,23,24,25,26,21,28,26,19,20,29,30,17,29,
                   31,32,19,20,34,30,17,19,20,36,37,30);
                                                                              {
          La tabla "dict" contiene las palabras que aparecen en los mensajes de
          error generados por el procedure error.
                                                                              }
         dict : array[1..37] of string[15] =
               ('unknown','character','illegal','comment','sintax','string',
                'constant','too','long','nonterminated','numeric','large',
                '32,767','used','sentential','stack','overflow','underflow',
                'compiler','error -','missing','option','name','on','?OPTION',
                'line','invalid','?PROGRAM','simbol','table','not',
                'inserted','into','xr (cross reference)','initialize','in',
                'prefix');
Type
                                  { tipo del registro de la tabla de simbolos }
         record_symtab = record
                         name : string[idlen];    { nombre del identificador  }
                         Stype : integer;         { tipo del identificador    }
                         dimen : integer;        { dimension del identificador}
                         use   : token  ;         { como es usado el identifi }
                         address:integer;         { localidad de memoria      }
                         xrhead: integer;         { cabeza de la lista xr     }
                         xrtail: integer;         { cola de la lista xr       }
                         link  : integer;         { liga al siguiente identifi}
                         end;

         linea         = string[81];
         string26      = string[26];
         string15      = string[15];
         parse_table   = array[1..N_of_symbols,1..N_of_terminals] of integer;

Var
         error_buf : array[0..9,1..4] of integer;
                     { Donde el numero de los errores y los parametros son al-
                       macenados mientras una linea esta siendo procesada     }

         temp      : boolean;
         ptr       : integer;
         i,j,k     : integer;
         lowname   : char;
         begin_tok : integer ;           { beginning pos. of token            }
         line_buf  : string[81];         { buffer de la linea de entrada      }
         line_ptr  : integer ;           { indice que apunta a line_buf       }
         code_debug: boolean ;           { bandera al generador de codigo     }
         codesave  : integer ;           { almacena "codeptr"                 }
{        eof1      : boolean ;           { senal de fin de programa           }
         error_mark: string[80];         { errores en la linea actual         }
         error_num : integer;            { # de errores detectados            }
         idptr     : integer;            { apuntador a la tabla de simbolos   }
         int_debug : boolean;            { rastreador del interprete          }
         jumplink  : integer;            { list head of jump fixups           }
         line_errors: integer;           { # de errores en la linea actual    }
         line_num  : integer;            { numero de la linea actual          }
         list_flag : boolean;            { requerimiento de una lista         }
         ll1_debug : boolean;            { para depurar el parser ll(1)       }
         new_line  : boolean;            { nueva linea leida por el scanner?  }
         next_token: token  ;            { proximo token de entrada           }
         no_code   : boolean;            { no genera codigo si es  true       }
         next_char : char;               { proximo caracter del scanner       }
         procidptr : integer;            { idptr para el ultimo procedimiento }
         scanner_debug: boolean;       { bandera que indica si imprimir tokens}
         scope     : char;               { alcance del identificador          }
         semsave   : integer;            { almacena sem_loop                  }
         strbuf    : string[strlen];     { para mantener las literales        }
         sym_debug : boolean;            { para imprimir la tabla de simbolos }
         value     : integer;            { valor de una constante             }
         xref_flag : boolean;            { requerimiento de referencia cruzada}

         codeptr, globalptr, gsymfree, gxrptr, localptr, lsymfree  : integer;
         lxrptr, procptr, sem_top : integer;
         entrada  : text;
         symtab   : array[1..ncode] of record_symtab; { Tabla de simbolos     }
         code     : array[1..ncode] of integer ;      { Area del Programa     }
         codeout  : file of integer;
         ghashtab : array[1..nhash] of integer;
         global   : array[0..nglobal] of integer;
         lhashtab : array[1..nhash] of integer;
         procinfo : array[1..npinfo] of integer;
         sem      : array[1..nsem] of integer;     { stack de semantica       }
         xr       : array[1..nxr] of integer;      { lista de cross reference }
         fte      : text;
         fparseta : file of parse_table;
         ll1_parsetab: parse_table;
         programa : string[12];
                                                                              {
                  Inicializa tablas ghashtab, global, lhashtab
                                                                              }
  Procedure inicializa_tablas;
    begin
       for i:=1 to nhash do begin ghashtab[i] := null; lhashtab[i] := null end;
       for i:=0 to nglobal do global[i] := 0
    end;
{----------------------------------------------------------------------------}
Procedure videoinv(letre:linea);
begin
     textbackground(white);textcolor(blue);
     write(letre); textbackground(black);textcolor(yellow) end;
{----------------------------------------------------------------------------}
Procedure encabezado(n:integer);
begin
      if n = 1 then
         begin
            window(1,1,80,1); textbackground(red); clrscr; gotoxy(2,1);
            textcolor(white);write('COMPILADOR GAUSS ');gotoxy(65,1)
         end
               else
         begin
            window(1,1,80,25); gotoxy(31,1); textbackground(blue);
            textcolor(white);write(' COMPILANDO : ',programa,' ');
            window(1,2,80,25); textbackground(black);textcolor(white); clrscr
         end;
      if n = 1 then
               begin write('CINVESTAV - IPN') ; textcolor(yellow) end
end;
{----------------------------------------------------------------------------}
Procedure abre_arch;
Var OK : boolean; x,y:integer;
 Begin
      window(1,2,80,25);
      repeat
        clrscr; gotoxy(10,12);write('Programa a Compilar  : '); x := wherex ;
        y := wherey; videoinv('            ');
        gotoxy(x,y); read(programa); assign(fte,programa);
        {$I-} reset(fte) {$I+}; OK := (IOresult = 0);
        if  not OK then begin clrscr; gotoxy(10,12); textcolor(red);
              videoinv('No se encuentra el Programa :');
              textcolor(yellow);write(' ',programa); delay(2500) end;
      until OK;
      clrscr; assign(fparseta,'parsetab.dat');
      reset(fparseta); read(fparseta,ll1_parsetab); close(fparseta);
      assign(codeout,'code.out')
  end;
{----------------------------------------------------------------------------}
                                                                              {
         El siguiente procedimiento es usado en algunos lugares para leer la
         siguiente linea de entrada, listandola si es necesario y pone las ban-
         deras y apuntadores apropiados.                                      }

  Procedure get_line;
  Var
     ii : integer;
    begin
         readln(fte,line_buf);
         for ii := 1 to length(line_buf) do
             if line_buf[ii] in ['A'..'Z'] then
                line_buf[ii] := chr(ord(upcase(line_buf[ii])) + 32);
         if ( copy(line_buf,1,8) <> '?program' ) then
                                 begin
                                      line_num := line_num + 1;
                                      if list_flag then
                                         WRITELN(line_num:2,'  :',line_buf)
                                 end;
         new_line := false;
         line_ptr := 0
    end;     { del procedimiento get_line     }



    Procedure error (err_numb,parm1,parm2,parm3 : integer);
{       ************************************************************
        *                                                          *
        *                       error                              *
        *                                                          *
        ************************************************************

        este procedimiento es utilizado para insertar un numero de error dado y
        sus parametros correspondientes a la variable "error_buf" ,asi estos --
        puden ser impresos cuando el procedimiento "list_err" es llamado. Un  -
        maximo de 10 errores por linea es permitido

        err_numb               /* cual error ocurrio     */
        parm1                  /* el primer parametro    */
        parm2                  /* el segundo parametro   */
        parm3                  /* el tercer parametro    */
                                                                              }
     Var
        code : integer;
        digit : string[1] ; { indica el numero de errores para la actual linea}

     Begin
   { Si hay mas de diez errores se sale, de otra forma inserta en una tabla   }

     if line_errors >= 10
        then line_errors := line_errors + 1
        else
         begin
          if not((ll1_debug) and (copy(error_mark,begin_tok,1) <> ' '))
{          if not(ll1_debug) or (copy(error_mark,begin_tok,1) = ' ')         }
            then
              begin
                str(line_errors,digit);
                { PUT STRING (digit) EDIT (line_errors)  }
                { SUBSTR (error_mark,begin_tok,1) := digit }
                insert(digit,error_mark,begin_tok);
                error_buf[line_errors,1] := err_numb;
                error_buf[line_errors,2] := parm1;
                error_buf[line_errors,3] := parm2;
                error_buf[line_errors,4] := parm3;
                line_errors := line_errors + 1
              end;
         end;
     end;          { de error }



    Function token_pr(token:token):string26;
{       ************************************************************
        *                                                          *
        *                       token_pr                           *
        *                                                          *
        ************************************************************

    Este procedimiento regresa la cadena de caracteres que representa el token
    dado, tambien determina si el token debe ser encerrado entre comillas o no
    dependiendo del tipo de token que sera regresado
                                                                              }

    Begin
         if (token = Nsimpident)  or (token = Nsimpconident) or
            (token = Narrayident) or (token = Narrayconident) or
            (token = Nprocident ) or (token = Nnewident )or
            (token = Nliteral)   or  (token = Nnumber ) or
            (token = Neof)
                   then token_pr := token_str[ord(token)]
                   else token_pr := concat('''',token_str[ord(token)],'''');
    end;    { de token_pr }


    Procedure llerror(stack_top,input:integer);
{       ************************************************************
        *                                                          *
        *                       llerror                            *
        *                                                          *
        ************************************************************

        Este procedimiento es utilizado para generar los mensajes de error los
        cuales ocurren como resultado de un error en la tabla del parse LL(1).
        El simbolo del tope del stack y el simbolo de la entrada son requeridos
        a la vez para determinar que mensaje de error debe ser impreso. La ge--
        neracion de un mensaje de error apropiado consiste en imprimir todos --
        los tokens posibles que pudieran ser apareados con el token de entrada.
        Esto es completado metiendo en una tabla todos los posibles tokens de
        un simbolo no terminal dado, e imprimiendo esta. Las tablas utilizadas
        para este proposito son explicadas abajo.

        " ffset " y " fftoken " son tablas utilizadas para facilitar la impre-
        sion de los mensajes de errore sintacticos.
        "ffset" es un vector de enteros. Contiene una entidad para cada simbo--
        lo noterminal de la gramatica. Esta entidad es el indice de el primero
        de una serie de tokens en "fftoken". Estos son los tokens los cuales --
        podrian aparecer donde es requerido el noterminal. El fin de la serie -
        de tokens es uno menor que el valor de la siguiente entidad en "ffset"
                                                                              }
    Const
         terminals = 58;
         symbols   = 123;
         ffset : array[terminals..symbols] of integer =
         ( 1,6,11,14,27,32,36,38,40,44,47,48,50,63,66,72,
          77,78,80,82,83,97,110,124,139,141,145,149,151,
          160,161,163,165,167,170,171,185,186,187,189,190,
          191,193,215,228,242,243,245,247,249,250,264,267,280,
          293,205,321,334,354,367,378,399,409,431,441,443);

         fftoken : array[1..442] of token =
    { program }           (Nproc,Ninteger,Nstring,Nlogical,Narray,

    { global  }            Nproc,Ninteger,Nstring,Nlogical,Narray,

    { core    }            Nproc,Nconst,Nnewident,

    { declaration list }   Ninteger,Nstring,Nlogical,Narray,Nsimpident,
                           Narrayident,Nprocident,Nreturn,Nif,Nloop,Nstop,
                           Nread,Nwrite,

    { procedure list }     Nproc,Ninteger,Nstring,Nlogical,Neof,

    { declaration }        Ninteger,Nstring,Nlogical,Narray,

    { entity list }        Nconst,Nnewident,

    { const list }         Ncomma,Nsemi,

    { type specifier }     Ninteger,Nstring,Nlogical,Narray,

    { simple type }        Ninteger,Nstring,Nlogical,

    { array }              Narray,

    { bound pair list }    Ncomma,Nrparen,

    { bound pair }         Nnot,Ntrue,Nfalse,Numinus,Nlength,
                           Nlparen,Nliteral,Nnumber,Nsimpident,Narrayident,
                           Nsimpconident,Narrayconident,Nprocident,

    { second bound }       Ncolon,Nrparen,Ncomma,

    { constant }           Numinus,Ntrue,Nfalse,Nnumber,Nliteral,Nlparen,

    { simple constant }    Numinus,Nnumber,Nliteral,Ntrue,Nfalse,

    { array constant }     Nlparen,

    { simple const list }  Ncomma,Nrparen,

    { ident list }         Ncomma,Nsemi,

    { procedure }          Nproc,

    { procedure tail }     Nforward,Ninteger,Nstring,Nlogical,Narray,
                           Nsimpident,Narrayident,Nprocident,Nreturn,
                           Nif,Nloop,Nstop,Nread,Nwrite,

    { procedure body }     Ninteger,Nstring,Nlogical,Narray,Nsimpident,
                           Narrayident,Nprocident,Nreturn,Nif,Nloop,
                           Nstop,Nread,Nwrite,

    { statement list }     Nsimpident,Narrayident,Nprocident,Nreturn,
                           Nif,Nloop,Nstop,Nread,Nwrite,Nendproc,
                           Nelse,Nendif,Nwhile,Nendloop,

    { parameter list }     Nlparen,Nsimpident,Narrayident,Nprocident,
                           Nforward,Ninteger,Nstring,Nlogical,Narray,
                           Nreturn,Nif,Nstop,Nloop,Nread,Nwrite,

    { parameters }         Ncomma,Nrparen,

    { parameter }          Ninteger,Nstring,Nlogical,Narray,

    { parameter type }     Ninteger,Nstring,Nlogical,Narray,

    { comma list }         Ncomma,Nrparen,

    { statement }          Nprocident,Nreturn,Nif,Nloop,Nstop,
                           Nsimpident,Narrayident,Nread,Nwrite,

    { procedure call }     Nprocident,

    { argument list }      Nlparen,Nsemi,

    { arguments }          Ncomma,Nrparen,

    { argument }           Nsimpident,Narrayident,

    { sublist }            Nlparen,Nrparen,Ncomma,

    { return stmt }        Nreturn,

    { ret expression }     Nnot,Numinus,Nlength,Nlparen,Ntrue,Nfalse,
                           Nliteral,Nnumber,Nsimpident,Nsimpconident,
                           Narrayident,Narrayconident,Nprocident,Nsemi,

    { if stmt }            Nif,

    { then clause }        Nthen,

    { else clause }        Nelse,Nendif,

    { while stmt }         Nloop,

    { stop stmt }          Nstop,

    { assigment stmt }     Nsimpident,Narrayident,

    { substring }          Nlparen,Nassign,Nconcat,Nindex,Nmult,Ndiv,
                           Nmod,Nand,Nplus,Nminus,Nor,Nlt,Ngt,Neq,Nge,Nle,
                           Nne,Ncomma,Nrparen,Nsubstr,Nsemi,Ncolon,

    { start }              Nnot,Numinus,Nlength,Nlparen,Ntrue,Nfalse,
                           Nliteral,Nnumber,Nsimpident,Nsimpconident,
                           Narrayident,Narrayconident,Nprocident,

    { length }             Nnot,Numinus,Nlength,Nlparen,Ntrue,Nfalse,
                           Nliteral,Nnumber,Nsimpident,Nsimpconident,
                           Narrayident,Narrayconident,Nprocident,Nrparen,

    { read stmt }          Nread,

    { input goal list }    Nsimpident,Narrayident,

    { input goals }        Ncomma,Nsemi,

    { input goal }         Nsimpident,Narrayident,

    { write stmt }         Nwrite,

    { expression list }    Nnot,Numinus,Nlength,Nlparen,Ntrue,Nfalse,
                           Nliteral,Nnumber,Nsimpident,Nsimpconident,
                           Narrayident,Narrayconident,Nprocident,Nusing,

    { expressions }        Ncomma,Nusing,Nrparen,

    { expression }         Nnot,Numinus,Nlength,Nlparen,Ntrue,Nfalse,
                           Nliteral,Nnumber,Nsimpident,Nsimpconident,
                           Narrayident,Narrayconident,Nprocident,

    { etail }              Ngt,Nlt,Neq,Nge,Nle,Nne,Ncolon,Ncomma,Nrparen,
                           Nsemi,Nsubstr,Nthen,Nusing,

    { part }               Nnot,Numinus,Nlparen,Ntrue,Nfalse,Nliteral,
                           Nnumber,Nsimpident,Nsimpconident,Narrayident,
                           Narrayconident,Nprocident,

    { ptail }              Nplus,Nminus,Nor,Ncolon,Ncomma,Nrparen,Nsemi,
                           Nsubstr,Nlt,Nle,Ngt,Nge,Neq,Nne,Nthen,Nusing,

    { term }               Nnot,Numinus,Nlength,Nlparen,Ntrue,Nfalse,
                           Nliteral,Nnumber,Nsimpident,Nsimpconident,
                           Narrayident,Narrayconident,Nprocident,

    { ttail }              Nmult,Ndiv,Nmod,Nand,Nplus,Numinus,Nor,Ncolon,
                           Ncomma,Nrparen,Nsemi,Nsubstr,Nlt,Nle,Ngt,Nge,
                           Neq,Nne,Nthen,Nusing,

    { factor }             Nnot,Numinus,Nlength,Nlparen,Ntrue,Nfalse,
                           Nliteral,Nnumber,Nsimpident,Nsimpconident,
                           Narrayident,Narrayconident,Nprocident,

    { index }              Nlength,Nlparen,Ntrue,Nfalse,Nliteral,Nnumber,
                           Nsimpident,Nsimpconident,Narrayident,Narrayconident,
                           Nprocident,

    { itail }              Nindex,Nmult,Ndiv,Nmod,Nand,Nplus,Nminus,Nor,
                           Nsemi,Ncomma,Nrparen,Nsemi,Nsubstr,Nlt,Nle,Ngt,
                           Nge,Neq,Nne,Nthen,Nusing,

    { catena }             Nlparen,Nsimpident,Nsimpconident,Narrayident,
                           Narrayconident,Nprocident,Ntrue,Nfalse,Nliteral,
                           Nnumber,

    { ctail }              Nconcat,Nindex,Nmult,Ndiv,Nmod,Nand,Nplus,Nminus,
                           Nor,Nsemi,Ncomma,Nrparen,Nsemi,Nsubstr,Nlt,Nle,
                           Ngt,Nge,Neq,Nne,Nthen,Nusing,

    { primary }            Nlparen,Nprocident,Nsimpident,Nsimpconident,
                           Narrayident,Narrayconident,Nnumber,Nliteral,
                           Ntrue,Nfalse,

    { proc_name }          Nnewident,Nprocident);

    Var
       { stack_top              simbolo que esta en el tope del stack  }
       { input                  simbolo que estuvo en la entrada       }
         i       ,            { indice para imprimir tokens            }
         last    ,            { ultimo token del ffset a imprimir      }
         token1  ,            { el token a imprimir                    }
         col : integer;       { indicador de columna para imprimir     }
    Begin
         write(' expecting ');
      { imprime los tokens que podrian haber aparecido en la entrada  }

         if stack_top <= N_of_terminals
            then write(token_pr(token(stack_top)))
            else
              begin
                col := 27;
                i := ffset[stack_top];
                last := ffset[stack_top + 1] - 1;
                while i <= last do
                  begin
                    token1 := ord(fftoken[i]);
                    write(token_pr(token(token1)));
                    col := col + length(token_str[token1]);
                    if i < last then
                       begin
                         write(' or ');
                         col := col + 4;
                         if col >= 60 then
                            begin
                              writeln('                        ');
                              col := 27
                            end;
                       end;
                    i := i + 1;
                  end;
              end;
         writeln('          but found ',token_pr(token(input)))
    end;    { de llerror }

     Procedure list_err;
{       ************************************************************
        *                                                          *
        *                       list_err                           *
        *                                                          *
        ************************************************************

        Este procedimeinto es utilizado para imprimir todos los errores de una
        linea dada. Los numeros de error han sido salvados en la estructura --
        "error_buf". El numero de error es utilizado como un numero de indice a
        la tabla "err_mesg_tab". La entidad de esta tabla para el error dado es
        un indice a la tabla "pat_space". Esta tabla contiene indices a la ta--
        bla "dict" la cual contiene las palabras que seran impresas. Este proce
        dimiento generara el mensage de error apropiado, y reinicializara la ta
        bla "error_buf" para la siguiente line de codigo fuente.
                                                                              }

    Function min(n1:integer;n2:integer):integer;
         begin
           if n1 < n2 then min := n1
                      else min := n2;
         end;
    Var
       i,j :integer;     { indices   }
    Begin
         { imprime la linea si aun no ha sido impresa, e imprime los errores
           asociados a ella                                                   }

         if list_flag then
            writeln(line_num:4,':  ',line_buf);
         writeln('      ',error_mark);

         { ahora genera el mensaje para cada error del error_buf }

         For  i:= 0 to min(9,line_errors - 1) do
            begin
              writeln('* * * * error (',i,'): ');
              if error_buf[i,1] = 8 then
                {  un mensaje especial de error del parse }
                   llerror(error_buf[i,2],error_buf[i,3])
                else
                 begin
                   j:= err_mesg_tab[error_buf[i,1]];
                   while j < err_mesg_tab[error_buf[i,1] + 1] do
                     begin
                       write(' ',dict[pat_space[j]]);
                       j:= j + 1
                     end;
                   writeln('.')
                 end;
            end;
        if line_errors > 10 then
               writeln('* * * * ',(line_errors - 10):3,'erros not reported ');
        error_num := error_num + line_errors;
        line_errors := 0;
        error_mark := {''} spc80
    end;     { de list_err }

    Procedure sem_err(message:string40); Forward ;
                                               { imprime errores de semantica }

{$I procedu1 }     { contiene la definicion de los procedimientos "lookup" ,  }
{$I procedu2 }     { "sym_rem" y "action"                                     }
{$I procedu3 }     { continua "action"                                        }
{$I scanner }      { contiene el procedimiento del scanner                    }

{$I llparse }      { contiene todo el procedimiento "llparse"                 }
{$I llparse1 }     { cotinuacion del "llparse"                                }


             { comienza procedimiento "init" }
begin
     encabezado(1); textbackground(black);
     abre_arch;
     encabezado(2);
     inicializa_tablas;                   { Este procedimiento fue adicionado }
     code_debug := false;                 { false es identico a   '0'B  }
     eof1 := false;
     error_mark := {''} spc80 ;
     error_num := 0;
     globalptr := 1;
     gsymfree := nhash;
     gxrptr := nxr - xrnode + 1 ;
     int_debug := false;
     line_errors := 0;
     line_num := 0;
     list_flag := true;
     ll1_debug := false;
     localptr := -3;
     lsymfree := 1;
     lxrptr := 1;
     next_char := ' ';
     next_token := Nnull;
     no_code := false;
     scanner_debug := false;
     scope := 'g';
     sem_top := 0;
     sym_debug := false;
     xref_flag := false;
                      { inserta 'main' en la tabla de simbolos}
     ptr := lookup('main');
     symtab[ptr].Stype := 0;
     symtab[ptr].use := Nprocident;
     symtab[ptr].dimen := 0;
     symtab[ptr].address := 1;
     procinfo[1] := 0;

     code[1] := 41;     {SSsaveabp}
     code[2] := 24;     {SSpush}
     code[3] := 7;
     code[4] := 17;     {SSjump}
     code[5] := 0 ;
     code[6] := ptr;
     code[7] := 51;     {SSstop}
     code[8] := 61 ;    {SSend_of_file}
     code[9] := 40 ;    {SSreturnval}
     jumplink := 5;
     codeptr := 10;
     codesave := 10;
     semsave := 0;

                   { inserta un 'end_of_file' a la tabla de simbolos          }
     ptr := lookup('end_of_file');
     symtab[ptr].Stype := integer(Nlogical);
     symtab[ptr].use := Nprocident;
     symtab[ptr].dimen := 0;
     symtab[ptr].address := 2;
     procinfo[2] := 8;
     procptr := 3;
     get_line;
     if (copy(line_buf,1,8) = '?program') then
                                              get_line;
     temp := llparse;

{              fixup jumps                                                    }
     while ( jumplink <> 0 ) do
           begin
                i := jumplink ;
                jumplink := code[i] ;
                idptr := code [i+1] ;
                code[i] := procinfo[symtab[idptr].address];
                code[i+1] := symtab[idptr].dimen;
                IF ( code[i] = 0 ) Then
                                   begin
                                      sem_err(concat(symtab[idptr].name,
                                        'procedure undefined'));
                                      code[i] := 51   {SSstop}
                                   end
           end;
     IF sym_debug then
                  begin
                  writeln('Tabla global de simbolos depurada:');
                  writeln;
                  write('Nombre','           Localidad','    liga');
                  writeln('    direccion');
                  writeln;
                  for i := 1 to nhash do
                      begin
                           ptr := ghashtab[i];
                           while ptr <> null do
                            begin
                            writeln(symtab[ptr].name:18,i:6,symtab[ptr].link:6,
                                      symtab[ptr].address:6);
                              ptr := symtab[ptr].link
                            end
                      end;
                  writeln
                  end;

    IF xref_flag then
       begin
            writeln; writeln('Referencias cruzadas globales');
            writeln; write('Nombre','           tipo','           Uso');
            writeln('                            dimenre  referencias');
            writeln;
            For i := gsymfree + 1 to  nhash do
                begin
                     lowname :='0';
                     For j:=gsymfree +1 to nhash do
                         IF (symtab[j].name < lowname ) then
                            begin
                                 ptr := j;
                                 lowname := symtab[j].name
                            end;
                     writeln(symtab[ptr].name:idlen,
                             token_str[symtab[ptr].Stype]:26,
                             token_str[ord(symtab[ptr].use)]:26,
                             symtab[ptr].dimen:2);
                     j:= symtab[ptr].xrhead;
                     WRITELN(spc70,xr[j]);
                     j := j + 1;
                     k := 1;
                     WHILE ( j <> symtab[ptr].xrtail+1 ) do
                           begin
                           IF (j mod xrnode) = 0 THEN j := xr[j];
                           IF  k = 10 then
                               begin
                                    writeln(',',spc70,xr[j]);
                                    k := 1
                               end
                           else
                               begin
                                    writeln(',',spc70,xr[j]);
                                    k := k + 1
                               end;
                           j := j + 1
                           end;
                     symtab[ptr].name := '0'
                end;
            writeln
       end;
    IF code_debug THEN
       begin
            writeln; writeln('code area is:'); writeln;
            i := 1;
            WHILE  ( i < codeptr) DO
                   begin
                        write(i:5,'     ', instr_str[code[i]]); j := i+1 ;
                        WHILE j <= (i + num_ops[code[i]]) DO
                            begin write('     ',code[j]:2); j := j + 1 end;
                        writeln;
                        i := j
                   end;
            writeln;
            writeln('EL area global es:');
            FOR i := 1 TO globalptr - 1 Do
                writeln(i:5,'     ',chr(global[i]));
            writeln;
            writeln('El area de procinfo is:');
            FOR i := 1 TO procptr-1 DO
                writeln(i:5,'     ',procinfo[i])
       end;
                                              { Graba el codigo en "code.out" }
       rewrite(codeout); write(codeout,codeptr); i := 1;
       WHILE  ( i < codeptr) DO
         begin                { Codigo Intermedio }
             write(codeout,code[i]); i := i + 1
         end;
                              {   Area "global"   }
       write(codeout,globalptr);
       FOR i := 1 TO globalptr - 1 Do
                write(codeout,global[i]);
                              {   Area procinfo   }
       write(codeout,procptr);
       FOR i := 1 TO procptr-1 DO
                write(codeout,procinfo[i]);
                              { Graba los valores de "no_code" y "int_debug" }
       i := ord(no_code); write(codeout,i);
       i := ord(int_debug); write(codeout,i) ;
       i := ord(real_eof); write(codeout,i) ;
       i := ord(scope) ; write(codeout,i);
       close(codeout)

{    If not no_code then execution_phase;  }

end;         { del procedimiento "init" }

             { comienza el procedimiento "compile" }
begin
       real_eof := false ;
       eof1 := false;
       while  not eof1 do
              begin
                  init;
                  if not real_eof then writeln
              end
end.      { de compile  }
