program execution_phase;

Const
     ncode   = 600 ;
     nglobal = 400 ;
     npinfo  = 100 ;
     nsize   = 200 ;
     strsize = 1000 ;
     N_of_instructions = 68 ;

         instr_str : array [1..N_of_instructions] of string[25] =
                  ('absolute','add','allocate','concatenate','dereference',
                  'dereference indirect','divide','dump','int =','int >=',
                  'int >','int <=','int <','int <>','index','newline','jump',
                  'read logical','load','load indirect','line number',
                  'multiply','negate','push','load absolute','remainder',
                  'string =','string >=','string >','string <=','string <',
                  'string <>','store','store indirect','subtract',
                  'substring until end','substring given length','template',
                  'return','return value','save act base ptr','incr stack ptr',
                  'and','not','or','branch','branch on false','pop',
                  'replace until end','replace given length','stop',
                  'store absolute','read integer','read string','start write',
                  'write integer','write logical','write string','space','tab',
                  'end of file','load string','load string indirect',
                  'load string absolute','store string',
                  'store string indirect','store string absolute','length');

                                                                              {
                "num_ops" entrega el numero de operandos asociados con cada
                instruccion                                                   }

         num_ops : array[1..N_of_instructions] of integer =
                  (1,0,2,0,1,1,0,1,0,0,{-}0,0,0,0,0,0,2,0,1,1,
                   1,0,0,1,0,0,0,0,0,0,{-}0,0,1,1,0,0,0,2,0,0,
                   0,1,1,0,1,1,1,0,0,0,{-}0,0,0,0,1,1,0,1,1,1,
                   0,1,1,0,1,1,0,0);

Type
         string80 = string[80]; string255 = string[255];
         area_str = array[0..strsize] of integer ;

Var
         codeptr, globalptr, procptr ,i,j : integer;
         code     : array[1..ncode] of integer ;      { Area del Programa     }
         codeout  : file of integer;
         global   : area_str;                   {array[0..nglobal] of integer;}
         procinfo : array[1..npinfo] of integer;
         fte      : text;
         no_code , int_debug : boolean;
         scope    : char;
         line_buf : string80;
         real_eof : boolean;
         abend : boolean;                    { bandera de paro de ejecucion }
         programa : string[12];

{----------------------------------------------------------------------------}
Procedure encabezado(n:integer);
begin
      if n = 1 then
         begin
            window(1,1,80,1); textbackground(red); clrscr; gotoxy(2,1);
            textcolor(white);write('COMPILADOR GAUSS ');gotoxy(65,1)
         end
               else
         begin
            window(1,1,80,25); gotoxy(26,1); textbackground(blue);
            textcolor(white);write(' INTERPRETANDO : ',programa,' ');
            window(1,2,80,25); textbackground(black);textcolor(white); clrscr
         end;
      if n = 1 then write('CINVESTAV - IPN') ;
end;
{----------------------------------------------------------------------------}

    Procedure recupera_codigo;
{       *************************************************************
        *                                                           *
        *                    recupera_codigo                        *
        *                                                           *
        *************************************************************

    Este procedimiento fue creado para recuperar el codigo objeto generado por
    el compilador GAUSS asi como los arreglos "global" y "procinfo" los cuales
    fueron guardados en el archivo de enteros "code.out" y que seran necesarios
    para la ejecucion del interprete.
}
    Var
       long : integer;

    Function FV(i:integer):boolean;
             begin
                  if i = 1 then FV := true
                           else FV := false;
             end;

    Begin
       assign(codeout,'code.out'); reset(codeout);
                                              { lee el codigo de "code.out" }
       read(codeout,codeptr); i := 1;
       WHILE  ( i < codeptr) DO
         begin                {  Lee el Codigo Intermedio }
             read(codeout,code[i]); i := i + 1
         end;
                              { Lee el Area "global" }
       read(codeout,globalptr);
       FOR i := 1 TO globalptr - 1 Do
                read(codeout,global[i]);
                              { Lee el Area procinfo  }
       read(codeout,procptr);
       FOR i := 1 TO procptr-1 DO
                read(codeout,procinfo[i]);
       read(codeout,i) ; no_code := FV(i);
       read(codeout,i) ; int_debug := FV(i);
       read(codeout,i) ; real_eof := FV(i);
       read(codeout,i) ; scope := chr(i);
                                   { se lee el nombre del programa compilado }
       read(codeout,long); programa := '';
       for i:= 1 to long do
           begin read(codeout,j); programa := concat(programa,chr(j)) end;
       close(codeout);
       if int_debug then
          begin
            writeln; writeln('El area de codigo es:'); writeln;
            i := 1;
            WHILE  ( i < codeptr) DO
                   begin
                        write(i:5,'     ', instr_str[code[i]]); j := i+1 ;
                        WHILE j <= (i + num_ops[code[i]]) DO
                            begin write('     ',code[j]:2); j := j + 1 end;
                        writeln;
                        i := j
                   end;
            writeln;
            writeln('EL area global es:');
            FOR i := 1 TO globalptr - 1 Do
                writeln(i:5,'     ',chr(global[i]));
            writeln;
            writeln('El area de procinfo is:');
            FOR i := 1 TO procptr-1 DO
                writeln(i:5,'     ',procinfo[i]);
            writeln( ' int_debug = ',int_debug:5,' no_code = ',no_code,
                     ' abend = ',abend)
          end
    end;


    Procedure execution_phase;
{       *************************************************************
        *                                                           *
        *                    execution_phase                        *
        *                                                           *
        *************************************************************

    Este procedimiento y todos los procedimientos llamados comprenden el inter-
    prete que ejecuta el codigo objeto generado por las rutinas de accion.
    Note que el codigo objeto es guardado en el arreglo global 'code'.
}
    Label
         opt53;
    Var
       rs : array[0..nsize] of integer;    { pila de la corrida  }
       sp : integer;                       { apuntador a la pila de la corrida}
       line_number : integer;
                 { numero de linea del programa fuente para mensajes de error }

       eof1  : boolean;                    { bandera de end-of-file       }
       input_stream : string[80];          { linea de entrada siguiente   }
       wp    : integer;                    { apuntador de escritura       }
       next_char : char;                   { siguiente caracter de entrada}
       chars : string[255];                { cadena temporal de caracteres}
       abp   : integer;                   { apuntador a la base de activacion }
       string_area : area_str;            { area de almacenamiento de string }
       str_ptr : integer;      { apuntador a la pila de almacenamiento string}
       descr_ptr : integer;    { apuntador al descriptor de la pila }
       prev_descr: integer;    { apuntador al ultimo descriptor }
       ic : integer;           { contador de intrucciones }
       count_eof: boolean;     { bandera agregada al codigo para detectar el
                                 fin de archivo }
       di1: integer;          { variable auxiliar utilizada en op54 }

{-----------------------------------------------------------------------------}
    Procedure inicializa_variables;
         Begin
              for i := 0 to nsize do
                  begin rs[i] := 0 ; string_area[i] := 0 end;
              sp := 0; count_eof := false;
              line_number := 0 ; input_stream := ''; real_eof := false;
              abend := false; eof1 := false; abp := 1;
              str_ptr := strsize; descr_ptr := 1; prev_descr := 0; ic := 1
         end;
{-----------------------------------------------------------------------------}
    Procedure dump;
{       *************************************************************
        *                                                           *
        *                            dump                           *
        *                                                           *
        *************************************************************

    Este procedimiento imprime la pila del run_time y el codigo de la pila al
    tiempo de la corrida, permitiendo al compilador ser depurado. El parametro
    es un parametro dummy
}
    Var
       i,j : integer ;      { contador de iteraciones }
       chars : string[2];   { variable string temporal }

    Begin   { comienza dump }
         writeln;writeln;writeln;
         writeln('*** run-time stack ***');
         for i := 1 to sp do
             writeln(i:3,':',rs[i]:6);
         writeln(' instruction counter is ',ic); writeln;writeln;
         writeln(' line number: ',line_number:4); writeln;writeln;
         writeln(' write pointer (wp): ',wp)
    end;    { de dump }

    Procedure next_instruction;
{       *************************************************************
        *                                                           *
        *                    next_instruction                       *
        *                                                           *
        *************************************************************

     Este procedimiento interpreta las instrucciones contenidas en el arreglo
     "code". La variable global "codeptr" contiene el numero de elementos con-
     tenidos en el arreglo "code"
}
    Label
         opt53;
    Type
        operation_code =
                (op0,op1,op2,op3,op4,op5,op6,op7,op8,op9,op10,
                op11,op12,op13,op14,op15,op16,op17,op18,op19,op20,
                op21,op22,op23,op24,op25,op26,op27,op28,op29,op30,
                op31,op32,op33,op34,op35,op36,op37,op38,op39,op40,
                op41,op42,op43,op44,op45,op46,op47,op48,op49,op50,
                op51,op52,op53,op54,op55,op56,op57,op58,op59,op60,
                op61,op62,op63,op64,op65,op66,op67,op68) ;

    Var
{      scope : char;                  { variable local o global }
       str,chars : string255;         { variables string tempoprales }
       t,i,n,ctr,size,p : integer;    { variables temporales  }
       number,digit : integer;        { utilizadas para convertir cadenas }
                                      { a enteros                         }
       numb : real;                   { utilizado para leer enteros       }
       neg,not_done,flag,flg,warnig : { variables booleanas temporales    }
                        boolean;

    Procedure error(line:string80;flag:integer); forward;
{-----------------------------------------------------------------------------}
    Function log(num:real):real;
    Begin
         log := ln(num) / ln(10)
    end;
{-----------------------------------------------------------------------------}
    Function run_stack(index:integer):integer;
{       *************************************************************
        *                                                           *
        *                        run_stack                          *
        *                                                           *
        *************************************************************

    Este procedimineto checa el indice a la pila run_time para asegurar su
    validez antes de regresar el valor de la localidad

                   index ;     es el indice al arreglo
}

    Begin   { comienza run_stack }
         if abend then run_stack := 1
                  else if (index < 1) or (index > sp)
                        then
                          begin
                            error('out of run_time stack area ',1);
                            run_stack := 1
                          end
                        else run_stack := rs[index];
    end;    { termina  run_stack }

    Function assign_rs(index:integer):integer;
{       *************************************************************
        *                                                           *
        *                        assign_rs                          *
        *                                                           *
        *************************************************************

    Este procedimiento checa que el indice sea valido y regresa un indice
    valido antes que una asignacion sea hecha al la pila run_time.

                   index :     indice a la pila run_time
}
    Begin   { comienza assign_rs }
         if abend then assign_rs := 0
                  else if (index < 1) or (index > sp)
                          then
                            begin
                              error('out of run_time stack area ',1);
                              assign_rs := 0
                            end
                          else assign_rs := index;
    end;    { termina  assign_rs }

    Function globall(index:integer):integer;
{       *************************************************************
        *                                                           *
        *                         globall                           *
        *                                                           *
        *************************************************************

    Este procedimiento checa que el indice al area de almacenamiento global
    sea valido.
                  index  :   indice al arreglo global
}
    Begin   { comienza globall }
         if abend
            then globall := 0
            else if (index < 1) or (index >= globalptr)
                    then begin
                         error('out of global storage area',1);
                         globall := 0
                         end
                    else globall := index;
    end;    { termina  globall }

    Procedure error;
{       *************************************************************
        *                                                           *
        *                           error                           *
        *                                                           *
        *************************************************************

    Este procedimiento imprime el mensaje de error que le pasan y pone la ban-
    dera "abend" si es necesario
                   line  :     mensaje de error;
                   flag  :     pone la bandera "abend" ?
}
    Begin   { comienza error }
         writeln; writeln;
         writeln('***  error -',line,'  ***');
         if line_number <> 0 then
            writeln('*** error occurs near line', line_number:4);
         if flag = 1 then abend := true
    end;    { termina  error }

    Function find(order_number:integer):integer;
{       *************************************************************
        *                                                           *
        *                          find                             *
        *                                                           *
        *************************************************************

    Este procedimiento regresa la localidad de una variable contenida en la
    direccion absoluta de la pila run_time

              order_number :   direccion absoluta
}
    Begin   { comienza find }
         if order_number < 0
          then
            begin
                 scope := 'l' ;
                 find := abp - order_number - 1
            end
          else
            begin
                  scope := 'g';
                  find := order_number
            end;
    end;    { termina  find }

    Procedure scan_over;
{       *************************************************************
        *                                                           *
        *                        scan_over                          *
        *                                                           *
        *************************************************************

    Este procedimiento explora en la entrada hasta que encuentra el siguiente
    tipo de datos valido ( esto es: integer, literal, Boolean.

}
    Var
       flag    ,
       warning : boolean;    { salto sobre caracteres no blancos }
       ii : integer;

    Begin   { comienza scan_over }
          flag := true;
          warning := false;
          if length(input_stream) > 0
             then delay(0)
             else readln(input_stream);
          if (copy(input_stream,1,7) = '?option') or
             (copy(input_stream,1,8) = '?program') or
             (copy(input_stream,1,7) = '?OPTION') or
             (copy(input_stream,1,8) = '?PROGRAM')
                     then begin
                            eof1 := true; line_buf := input_stream
                          end;
          while (not eof1) and flag do
             begin
               if (copy(input_stream,1,1) = '-') or
                  (copy(input_stream,1,1) >= '0') and
                  (copy(input_stream,1,1) <= '9') or
                  (copy(input_stream,1,1) <= ' ')
                  then if length(input_stream) > 1
                          then if (copy(input_stream,1,1) = '-') and
                                  (copy(input_stream,2,1) <= '9') and
                                  (copy(input_stream,2,1) >= '0')
                                  then flag := false
                                  else if (copy(input_stream,1,1) <> '-')
                                          then flag := false
                                          else warning := true
                          else if (copy(input_stream,1,1) >= '0') and
                                  (copy(input_stream,1,1) <= '9')
                                  then flag := false
                                  else delay(0)
                  else if length(input_stream) >= 4
                          then if (copy(input_stream,1,4) = 'true') or
                                  (copy(input_stream,1,4) = 'TRUE')
                               then  flag := false
                               else if length(input_stream) >= 5
                                     then if (copy(input_stream,1,5) = 'false')
                                           or(copy(input_stream,1,5) = 'FALSE')
                                               then  flag := false;
               if  copy(input_stream,1,1) <> ' '
                  then flag := false
                  else begin
                     input_stream := copy(input_stream,2,length(input_stream));
                         warning := true
                       end;
(*               if (length(input_stream) > 1) and flag
                 then input_stream := copy(input_stream,2,length(input_stream))
                 else if flag
                         then
                           begin
                             readln(input_stream);
                             if (not eof1) and (not real_eof)
                              then if (copy(input_stream,1,7) = '?option')or
                                      (copy(input_stream,1,8) = '?program')
                                     then begin
                                            eof1 := true;
                                            line_buf := input_stream
                                          end;
                           end;                                          *)
             end;
             if warning
                then error('ignored characters in input ',2);
    end;    { termina  scan_over }

    Function stringf(descriptor:integer):string255;
{       *************************************************************
        *                                                           *
        *                         stringf                           *
        *                                                           *
        *************************************************************

    Este procedimiento regresa la cadena almacenada en la localidad designada
    por el parametro en el area de almacenamiento string.

                   descriptor  :       descriptor de la cadena
}
    Var            flg : boolean;   { bandera local de "string"   }

    Function find_string
        (string_area:area_str;descriptor:integer;scope:char):string255;
{       *************************************************************
        *                                                           *
        *                         find_string                       *
        *                                                           *
        *************************************************************
    Este procedimiento regresa la cadena dado su posicion de inicio en el arre-
    glo que se le pasa como parametro
               string_area :         area de almacenamineto de la cadena;
               descriptor  :         apuntador al descriptor;
               scope       :         indica si la cadena es de "global" o de
                                      "string_area"

}
   Var
      location ,         { localidad dentro de la cadena }
      len      ,         { logitud de la string }
      i :   integer;     { variable temporal    }
      str : string255;   { cadena a regresar    }
      flg : boolean;     { bandera local        }
      dummy_loc,aux:integer; { temporales necesaria   }

    Begin   { comienza find_string }
         { calcula la cadena }
         str := '';  flg := true;
         location := string_area[descriptor + 1] * 32767 +
                     string_area[descriptor+2];
         if scope = 's'
            then begin dummy_loc := location + 1; aux := 0 end
            else begin dummy_loc := location; aux:= 1 end;{ esto fue agregado }
         len := string_area[descriptor];
         if len < 0 then len := -len;
         if len = 0 then begin flg := false; find_string := '' end;
         if flg
            then
              begin
                 for i := dummy_loc to (location + {(}len {DIV 2)-1)} -aux ) do
                     str := concat(str,chr(string_area[i]));
(*                 if (len mod 2) <> 0 then
                    str := concat(str,chr(string_area[location+ len DIV 2]));*)
                 find_string := str
              end
    end;    { termina  find_string }

    Begin   { comienza stringf }
         { fuera de limites ?  }
         flg := true;
         if descriptor >= 0
            then if (descriptor >= descr_ptr) or (descriptor = 0)
                    then begin
                              error('out of string storage area',1);
                              flg := false; stringf := ''
                         end
                    else delay(0)
            else if abs(descriptor) >= globalptr
                    then begin
                              error('out of global storage area',1);
                              flg := false; stringf := ''
                         end;
         if flg then
            if descriptor > 0
              then stringf := find_string(string_area,descriptor,'s')
              else
               if global[globall(-descriptor)] > 0
           then stringf := find_string(global,global[globall(-descriptor)],'g')
                else
          stringf := find_string(string_area,-global[globall(-descriptor)],'s');
    end;    { termina stringf }

    Function descriptor(stringar:string255):integer;
{       *************************************************************
        *                                                           *
        *                        descriptor                         *
        *                                                           *
        *************************************************************

    Este procedimiento regresa el descriptor de la cadena pasada como parametro
    una vez que la cadena es guardada en el area de almacenamiento string.

}
   Var
      i,j : integer;           { contadores de iteraciones }
      flg,flag : boolean;      { bandera boolena           }
{     stringar: string255      { cadena a ser guardada     }

    Procedure garbage_collect;
{       *************************************************************
        *                                                           *
        *                     garbage_collect                       *
        *                                                           *
        *************************************************************

    Este procedimiento ejecuta la recoleccion de basura en el area string local
    recuperando el espacio no utilizado que alguna vez almaceno cadenas
}
    Var
       i,j : integer;           { contadores de iteracion }
       previous : integer;      { descriptor previo       }
       flag : boolean;          { bandera logica          }

    Begin   { comienza garbage_collect }
         { busca el primer descriptor }
         prev_descr := 0;
         i := 1;
         previous := 0;
         while (abs(string_area[i]) / 2 + (abs(string_area[i]) mod 2) +
               string_area[i + 1] * 32767 + string_area[i + 2] < strsize) and
               (i < descr_ptr - 4 ) do
               i := i + 4;
         { busca observando la primer localidad libre }
         flag := true;
         while flag and (string_area[i + 3] > 0) do
               if string_area[i] < 0
                  then flag := false
                  else begin
                         i := string_area[i + 3];
                         previous := i ; prev_descr := i
                       end;
         { no hay localidades libres }
         if not flag then
            begin
              { mueve las cadenas para recuperar espacio }
              str_ptr := abs(string_area[i]) div 2+(abs(string_area[i]) mod 2)-
                         1 + string_area[i + 1] * 32767 + string_area[i + 2];
              while i <> 0 do
                 begin
                   if string_area[i] < 0
                      then  { pasa sobre una localidad libre }
                        string_area[i + 2] := -1
                      else
                        begin
                          prev_descr := i;
                          if previous <> 0 then string_area[previous + 3] := i;
                          previous := i;

                          { copia la string }
                          for j := string_area[i+1] * 32767 + string_area[i+2]+
                                string_area[i] div 2 + (string_area[i] mod 2)-1
                           downto string_area[i+1] * 32767+ string_area[i+2] do
                                begin
                                  string_area[str_ptr] := string_area[j];
                                  str_ptr := str_ptr - 1;
                                end;
                          string_area[i + 1] := (str_ptr + 1) div 32767;
                          string_area[i + 2] := (str_ptr + 1) mod 32767
                        end;
                   j := i;
                   i := string_area[i + 3];
                   string_area[j + 3] := 0
                 end;
            end;
    end;    { garbage_collect }

    Begin   { comienza descriptor }
    { busca la primer localidad vacia }
         i := 1;
         flag := true; flg := true;
         while (i < descr_ptr) and flag do
                 if string_area[i + 2] < 0
                  then flag := false
                  else i := i + 4;
         if flag then
            begin
              i := descr_ptr;
              descr_ptr := descr_ptr + 4
            end;

    { desbordamiento en el area de almacenamiento }
         if descr_ptr >= str_ptr - {(}length(stringar) {/ 2 - 1) -
                          (length(stringar) mod 2)) }
            then garbage_collect;
         if descr_ptr >=  str_ptr - {(}length(stringar) {/ 2 - 1)
                         - (length(stringar) mod 2)  }
            then begin
                  error('local string storage area overflow',1);
                  flg := false ; descriptor := 0
                 end;
         if flg
            then begin
                   string_area[i] := length(stringar);
                   string_area[i+1] := 0;
                   string_area[i+2] := str_ptr - {(}length(stringar) {div 2 -1)
                                       - ( length(stringar) mod 2 )};
                   string_area[i+3] := 0;
                   if prev_descr <> 0
                      then string_area[prev_descr + 3] := i;
                   prev_descr := i;

             { almacena la string }
                   str_ptr := str_ptr - length(stringar) {div 2 -
                              (length(stringar) mod 2)};
                   for j := 1 to length(stringar)  do
                       string_area[str_ptr + j {div 2 + 1}] :=
                                                       ord(copy(stringar,j,1));
(*                   if (length(stringar) mod 2) <> 0
                     then string_area[str_ptr + j div 2 + 1] := ord(' ');   *)
                   descriptor := i
                 end;
    end;    { termina  descriptor }

{$i resint }                  { resto del codigo del interprete }

{$i inter1.pas }    { incluye el resto  del la funcion next_instructon }
              else   writeln ('********* NO SE ENCONTRO **************');

            end;    { del case }

    end;         { termina next_instruction }
{=============================================================================}
    begin   { de execution_phase  }
         inicializa_variables;
         writeln;writeln('output -->'); writeln;
         while (not abend) and (not no_code) do
               next_instruction;
         if int_debug then dump
    end;
{=============================================================================}
begin
     abend:= false;
     encabezado(1);
     recupera_codigo;
     encabezado(2);
     execution_phase;
end.
