{ [[[[[[[[[[[[  CONTINUACION DE LA FUNCION "llparse.pas      ]]]]]]]]]]]]]] }
        Procedure s_push(prod_no:integer);
{       ************************************************************
        *                                                          *
        *                         s_push                           *
        *                                                          *
        ************************************************************

        El procedimiento "push" mete los tokens de la parte derecha de una pro-
        duccion, dado el numero de la misma, al stack del parse
                                                                              }
   Var
      i : integer;       { indice a la tabla rhs_prod   }

   begin
        i := prod_index[prod_no + 1] - 1;
        while i >= prod_index[prod_no]
              begin
                if parse_top >= parse_limit then
                   begin
                     error(6,0,0,0);
                     list_err;
                     HALT
                   end;
             parse_top := parse_top + 1;
                parse[parse_top] := rhs_prod[i];
                i := i - 1
              end;
   end;          { de s_push  }

        Procedure s_pop;
{       ************************************************************
        *                                                          *
        *                         s_pop                            *
        *                                                          *
        ************************************************************

        Este procedimiento sacara el elemento del tope del stack del parse,
                                                                              }
     begin
          if parse_top  <= 1 then
             begin
               error(7,0,0,0);
               list_err;
               HALT
             end;
          parse_top := parse_top - 1
     end;      { de s_pop }

        Procedure err_hand(var parse:parse_stack;
                           parse_top,true_top:integer;next_token:token);
{       ************************************************************
        *                                                          *
        *                         err_hand                         *
        *                                                          *
        ************************************************************

        El procedimiento "err_hand" es utilizado para la recuperaracion de un
        error mientras se esta ejecutando el parse del programa. Basicamente,
        el metodo involucra buscar un simbolo (terminal o noterminal) en el
        stack el cual puede generar el simbolo de entrada. Los simbolos que es-
        tan sobre este simbolo en el stack seran removidos, y la porcion de la
        produccion la cual puede generar el simbolo de entrada sera metida al
        stack. Si esto falla, entonces el simbolo de entrada sera eliminado, y
        entonces el parser continuara analizando, si es posible. Para una des--
        cripcion completa de este metodo, ver la sec. 6-2.5 de Tremblay and So-
        renson del libro " The Theory and Practice of Compiler Writing " .

        La tabla "prefix" es utilizada para determinar si el simbolo en el
        stack puede producir el simbolo de la entrada. La entidad 0 indica que
        esto no es posible. Todas las otras entidades xxxyy, donde "xxx" indica
        la produccion a la que debe ser expandida el simbolo del stack, y "yy"
        indica cual elemento de la expansion produce el simbolo de la entrada
        dado
                                                                              }


       Var
          s:token;
          i,j:integer;    {  indices  variables  }

   Procedure fixup(var parse : parse_stack; i:integer; next_token : token);
{       ************************************************************
        *                                                          *
        *                       fixup                              *
        *                                                          *
        ************************************************************

        Este procedimiento tomara el simbolo del tope del stack, y expandira
        las porciones de el hasta que el simbolo del tope del stack sea el  -
        mismo que el actual simbolo de la entrada.
                                                                              }
    Var
       p,          { entidad a prefix }
       prod,       { parte de la produccion p }
       symbol,     { parte del simbolo de p }
       lo,         { indicaciones lo y hi }
       hi,         { limite de la produccion a ser metida al stack }
       j : integer;{ indice }

    Begin           { de fixup }
         while parse[i] <> next_token do
               { asegura que parse[i] es un no terminal. La tabla prefix
                 puede contener este tipo de error dentro               }
               begin
                 if parse[i] <= token(N_of_terminals) then
                    begin
                      error(14,0,0,0);
                      list_err;
                      HALT
                    end;
               { primero obtiene el numero de produccion y el simbolo de la
                 produccion que puede producir el simbolo de la entrada, uti-
                 lizando la tabla "prefix"                                    }

                 p := prefix[ord(parse[i]),ord(next_token)];

               { checa si existe error por medio de la tabla   }

                 if p = 0 then
                    begin
                      error(14,0,0,0);
                      list_err;
                      HALT
                    end;
                 prod := trunc( p / 100 );
                 symbol := p mod 100;
                 i := i - 1;
                 lo := prod_index[prod];
                 for j:=1 to symbol do
                     begin
                       if rhs_prod[lo] > token(N_of_terminals)
                                                         then no_code := true;
                       while rhs_prod[lo] >token(122) do
                             lo := lo + 1;
                     end;
                 lo := lo - 1;
                 hi := prod_index[prod+1] - 1;

               { ahora metemos al stack el resto de la produccion la cual puede
                 producir el simbolo de la entrada                            }

                 for j := hi downto lo  do
                     begin
                       i := i + 1;
                       parse[i] := rhs_prod[j];
                     end;
               end;
    end;            { de fixup }

    begin           { err_hand }
         { El principal ciclo del procedimiento va hacia abajo del stack, bus-
           cando un simbolo que pueda producir el actual simbolo de la entada}

         error(8,ord(parse[parse_top]),ord(next_token),0);
         for i := true_top downto 1 do
             begin
               s := parse[i];
               if s > token(122) then no_code := true
                          else if s = next_token
                                  then begin
                                         true_top := i;    { checar esto }
                                         parse_top := i
                                       end
                                  else if s > token(N_of_terminals)
                                     then if prefix[ord(s),ord(next_token)]<> 0
                                           then begin
                                                  fixup(parse,i,next_token);
                                                  true_top:= i; { checar esto }
                                                  parse_top := i
                                                end;
             end;
           { no puede encontrar algo en el stack que produsca el simbolo de la
             entrada . Elimina el simbolo de la entrada                       }
             if ll1_debug then
                  writeln('* * * * ',token_pr(next_token),
                          ' has been deleted from input stream');
              no_code := false;
              next_token := scanner
    end;   { del err_hand  }

   Procedure stack_pr(var parse : parse_stack; parse_top,true_top : integer);
{       ************************************************************
        *                                                          *
        *                       stack_pr                           *
        *                                                          *
        ************************************************************

        Este procedimiento es utilizado para imprimir el contenido del stack
        del parse e indica donde estan localizados los apuntadores del tope
        del stack y del "true_top"

        parse        stack del parsing
        parse_top    tope anterior del stack
        true_top     tope actual del stack
        i            un indice
                                                                              }

    Begin    { de stack_pr  }
    writeln('stack contents :'); writeln;
    writeln('true_top ->');
    for i:= true_top downto 1 do
        begin
          if parse[i] < token(123)
                         then write('              ',token_str[ord(parse[i])])
                       else write('              ','action ',ord(parse[i])+78);
          if i = parse_top then write (' <- parse_top');
          writeln
        end;
    end;     { de stack_pr  }

 begin       { de llparse   }
{      assign(fparseta,'parsetab.dat');      { Abre el archivo que contiene la }
{      reset(fparseta);                      { la tabla del parse y a continua-}
{      read(fparseta,ll1_parsetab);          { cion lo carga a ll1_parse       }
      parse_top := 2; true_top := 2;
      next_token := scanner;
      parse[1] := Neof;
      parse[2] := Sglobal;
      llparseflg := false;
      while not llparseflg do
          begin
            while parse[parse_top] > token(122)
                  begin
                    {  llama a rutinas de semantica }
                    action(ord(parse[parse_top]));
                    parse_top := parse_top -1
                  end;
            if ll1_debug then
               begin
                    stack_pr(parse,parse_top,true_top); writeln;
                    writeln('input symbol is ',token_str[ord(next_token)]);
               end;
            parse_action:= ll1_parsetab[ord(parse[parse_top]),ord(next_token)];
            if (parse_action >= 1) and (parse_action < Apop) then
               begin
                 if ll1_debug then
                    writeln('parse action = expand',' ''',
       token_str[ord(parse[parse_top])],'''','(',parse_action,')');
                 s_pop;
                 s_push(parse_action);

             { restablece true_top si esta produccion no se expande a un lado
               derecho, de una regla, nulo                                    }

                 i := prod_index[parse_action + 1] - prod_index[parse_action];
                 if i > 1 then true_top := parse_top
                          else
                           if (rhs_prod[prod_index[parse_action]] < token(123))
                               and (i = 1)
                               then true_top := parse_top;
               end
              else
               begin
                 if ll1_debug then
                    writeln('parse action = ',parse_string[parse_action]);
                 if parse_action = Apop
                    then
                      begin
                        s_pop;
                        while parse[parse_top] > token(122) do
                              { llama a rutina de semantica }
                              begin
                                action(ord(parse[parse_top]));
                                parse_top := parse_top - 1
                              end;
                        true_top := parse_top;
                        next_token := scanner;
                      end
                    else
                      if parse_action = Aaccept
                        then
                         begin
                           if line_errors > 0 then list_err;
                           llparseflg:= true
                         end
                        else
                         err_hand(parse,parse_top,true_top,next_token);
               end;
            llparse := true
          end
 end;  { del llparse }
