              { [[[[[[[[[ PROCEDU1.PAS ]]]]]]]]]]] }

Function lookup(name:string15):integer;
{       ************************************************************
        *                                                          *
        *                       lookup                             *
        *                                                          *
        ************************************************************

     Este procedimiento fue diseado para buscar en la tabla de simbolos. La -
     organizacion de la tabla de simbolos se logro por el metodo de hash. Exis-
     ten dos tablas Hash, "lhashtab" y la "ghashtab", las cuales son usadas pa-
     ra simbolos locales y globales, respectivamente. Ambas tablas contienen a-
     puntadores a las cabezas de las cadenas de simbolos ubicados en cierta lo-
     calidad. La tabla de simbolos actual consiste de una sola tabla con los --
     simbolos locales ocupando la localidades menores de la tabla, y los simbo-
     los globales ocupando las localidades mas altas de la tabla. El parametro
     "name" contiene el nombre que sera buscado.
     El metodo de hash utilizado es el metodo de division, con la suma de los -
     los valores EBCDIC del primer y ultimo caracter de "name" y con la lon--
     gitud de "name" utilizada como metodo de precondicion
                                                                              }

    Var
       hash ,             { localizacion hash  }
       symptr,            { apuntador a la tabla de symbolos }
       i, temp, xrptr:integer;
       found_flg : boolean;
    Begin
         { calcula el valor hash de un identificador  }
         hash := length(name);
         temp := ord(copy(name,hash,1));
{         val(copy(name,hash,1),temp,i); }
         hash := hash + temp;
         temp := ord(copy(name,1,1));
{         val(copy(name,1,1),temp,i); }
         hash := ((hash + temp) mod nhash) + 1;

         { primero busca en la tabla local }
         { luego busca en la tabla global }

         i := 1; found_flg := false;
         while not found_flg and (i <= 2) do
            begin
              if i = 1 then symptr := lhashtab[hash]
                       else symptr := ghashtab[hash];
              while symptr <> null do
               begin
                if symtab[symptr].name = name then
                   begin
                     { identificador fue encontrado }
                     symtab[symptr].xrtail := symtab[symptr].xrtail + 1;
                     if ((symtab[symptr].xrtail) mod xrnode) = 0 then
                        begin
                          { obtiene otro xrnode }
                          if lxrptr > gxrptr then
                             begin
                               error(13,0,0,0);
                               lxrptr := lxrptr - xrnode
                             end;
                          if scope = 'l'
                             then
                              begin
                               { identificador local }
                               xrptr := lxrptr;
                               lxrptr := lxrptr + xrnode
                              end
                             else
                              begin
                                { identificador global }
                                xrptr := gxrptr;
                                gxrptr := gxrptr - xrnode
                              end;
                          { liga el siguiente xrnode }
                          xr[symtab[symptr].xrtail] := xrptr;

                          { pone xrtail al frente de la siguiente lista }
                          symtab[symptr].xrtail := xrptr
                        end;

              { inserta el numero de linea en la lista de referencias cruzadas}
                     xr[symtab[symptr].xrtail] := line_num;
                     lookup := symptr;
                     found_flg := true
                   end;
                symptr := symtab[symptr].link
               end;
             i:= i+ 1
            end;
         if not found_flg then
            begin
              { la busqueda ha fallado }
              if lsymfree > gsymfree then
                 begin
                   error(12,0,0,0);
                   if scope = 'g' then HALT;
                   lsymfree := lsymfree - 1
                 end;
              if lxrptr > gxrptr then
                 begin
                   error(13,0,0,0);
                   lxrptr := lxrptr - xrnode
                 end;
              if scope = 'l'
                 then
                   begin
                     { identificador local }
                     symptr := lsymfree;
                     lsymfree := lsymfree + 1;
                     symtab[symptr].link := lhashtab[hash];
                     lhashtab[hash] := symptr;
                     xrptr := lxrptr;
                     lxrptr := lxrptr + xrnode
                   end
                 else
                   begin
                     { identificador global }
                     symptr := gsymfree;
                     gsymfree := gsymfree - 1;
                     symtab[symptr].link := ghashtab[hash];
                     ghashtab[hash] := symptr;
                     xrptr := gxrptr;
                     gxrptr := gxrptr - xrnode
                   end;
              { ahora ponemos os campos de la nueva entidad }
              symtab[symptr].name := name;
              symtab[symptr].use := Nnewident;
              symtab[symptr].Stype := 0;
              symtab[symptr].xrhead := xrptr;
              symtab[symptr].xrtail := xrptr;
              xr[xrptr] := line_num;
              lookup := symptr
            end;
    end;       { de lookup }

    Procedure sym_rem;
{       ************************************************************
        *                                                          *
        *                       sym_rem                            *
        *                                                          *
        ************************************************************

    Este procedimiento es diseado para remover el simbolo de la tabla de sim-
    bolos al finalizar el procedimiento. Al mismo tiempo la tabla local "lhas-
    tab" es reinicializada de tal forma que todos los elementos de esta tabla
    sean nulos. Si la bandera "sim_debug" esta puesta, entonces la estructura
    de la tabla local de simbolos es desplegada. Si "xref_flag" esta puesta, el
    el contenido de la tabla de simbolos sera impreso antes de que ellos sean
    removidos
                                                                              }
    Var
       i,j,k,ptr: integer;
       lowname : char;
    Begin
         if sym_debug then
            begin
              writeln;writeln('symbol table debug of ',symtab[procidptr].name);
              writeln;writeln('name','       ','hash loc.','     ','link',
                              '      ','address'); writeln;
              for i := 1 to nhash do
                  begin
                    ptr := lhashtab[i];
                    while  ptr <> null do
                      begin
                       writeln(symtab[ptr].name,'   ',i,'   ',symtab[ptr].link,
                               '   ',symtab[ptr].address);
                       ptr := symtab[ptr].link
                      end
                  end;
              writeln
            end;
         if xref_flag then
            begin
              writeln;writeln('cross reference of ',symtab[procidptr].name);
              writeln;writeln('name','    ','type','    ','use','    ','dimen',
                              '   ','references'); writeln;
              for i := 1 to lsymfree - 1 do
                  begin
                    lowname := '0';
                    for j := 1 to lsymfree - 1 do
                        if symtab[j].name < lowname then
                           begin
                             ptr := j;
                             lowname := symtab[j].name
                           end;
                    writeln(symtab[ptr].name,'  ',token_str[symtab[ptr].Stype],
                            '    ',token_str[ord(symtab[ptr].use)],'    ',
                            symtab[ptr].dimen);
                    j := symtab[ptr].xrhead;
                    writeln(spc70,xr[j]:3);
                    j := j + 1;
                    k := 1;
                    while  j <> (symtab[ptr].xrtail + 1) do
                      begin
                        if (j mod xrnode) = 0 then j := xr[j];
                        if k = 10
                          then
                            begin
                              writeln(spc70,',',xr[j]);
                              k := 1
                            end
                          else
                            begin
                              writeln(', ',xr[j]);
                              k := k + 1
                            end;
                        j := j + 1
                      end;
                    symtab[ptr].name:='0'
                  end;
              writeln
            end;
         localptr := -3;
         for i := 1 to nhash  do  lhashtab[i] := null;
         lsymfree := 1;
         lxrptr := 1
    end;    { sym_rem }

    Procedure action(action_number:integer);
{       ************************************************************
        *                                                          *
        *                       action                             *
        *                                                          *
        ************************************************************

    Las rutinas de accion son utilizadas para checar sintaxis sensibles de con-
    texto y para la generacion de codigo
                                                                              }
    Var
       i : integer;
       flg : boolean;


    Function store_lit:integer;
{       ************************************************************
        *                                                          *
        *                     store_lit                            *
        *                                                          *
        ************************************************************

    Este procedimiento es responsable de almacenar una literal en el area glo-
    bal y regresar el valor de su referencia
                                                                              }
    Var
       value,z,i : integer;
    begin
    value := globalptr;
    z := length(strbuf);
    global[globalptr]:= globalptr + 1;
{   global[globalptr+1]:= z*2;             9/2/98                             }
    global[globalptr+1]:= z;
    global[globalptr+2]:= 0;
    global[globalptr+3]:= globalptr + 4;
    globalptr := globalptr + 4;
    for i := 1 to z do
          begin
             global[globalptr] := ord(copy(strbuf,i,1));
             globalptr:= globalptr + 1
          end;
{    if i = z then begin
                  val(concat(copy(strbuf,z,1),' '),global[globalptr],j);
                  globalptr:= globalptr + 1
                  end; }
    store_lit:= - value
    end;          { de store_lit }

    Procedure template;
{       ************************************************************
        *                                                          *
        *                       template                           *
        *                                                          *
        ************************************************************

    Este procedimiento es responsable de crear una plantilla de arreglo.
    La direccion de la plantilla estara en " sem[sem_top].
    La plantilla estara en el area global si esta puede ser calculada en el
    tiempo de compilacion, de otra manera, estara en el area local            }

    Var
       i,size,constant,temp,codeptr_2:integer;
    begin
         if scope = 'l' then
                        begin
                         i := codesave;
                         codeptr_2 := codeptr - 2;
                         while i <= codeptr_2 do
                           begin
                             if code[i] <> 24 {SSpush}
                 { la expresion no puede ser evaluada a tiempo de copilacion}
                             then
        { escribe el codigo para generar la plantilla a tiempo de la corrida }
                             begin
                               code [codeptr] := ord(SStemplate); {SStemplate}
                               code [codeptr + 1] := localptr;
                            code [codeptr + 2] := sem[sem_top-1];
                               codeptr := codeptr + 3;
                         { guarda espacion para la plantilla en el area local }
                               sem[sem_top-2] := localptr;
                               localptr := localptr - 3 * sem[sem_top -1] - 2
                             end;
                           i := i+ 2
                           end;
                        end
                  else  { genera una plantilla }
                    begin
                      sem[sem_top-2] := globalptr;
                      globalptr := globalptr + 2;
                      constant := 0;
                      i := codesave ;
                      while i <= codeptr - 4 do
                        begin
                          global[globalptr] := code[i + 3] - code[i + 1] + 1;
                          if global[globalptr] < 1 then
                                   begin
                                     sem_err('lower bound exeeds upper bound');
                                     global[globalptr] := 1;
                                     code[i+3]:= code[i+1]
                                   end;
                          global[globalptr + 1] := code [i+1];
                          global[globalptr + 2] := code [i + 3];
                          constant := constant * global[globalptr] - code[i+3];
                          globalptr := globalptr + 3;
                          i := i + 4
                        end;
                      size := global[globalptr - 3];
                      i := globalptr - 6;
                      while i >= sem[sem_top - 2]+2  do
                        begin
                          temp := global[i];
                          size := size * temp;
                          global[i] := size;
                          i := i - 3
                        end;
                      i := sem[sem_top - 2];
                      global[i] := constant;
                      global[i + 1]:= sem[sem_top - 1];
                      sem[sem_top - 3] := size;
                      sem[sem_top - 4] := constant;
                      { reinicializa el codeptr }
                      codeptr := codesave
                    end;
    end;   { de template }

    Procedure code_fix(popcount,pushcount:integer); Forward;

    Procedure relation(tok:token; stri,inti:instructions);
{       ************************************************************
        *                                                          *
        *                       relation                           *
        *                                                          *
        ************************************************************
                                                                              }
    Begin
     if sem[sem_top] <> sem[sem_top - 1]
      then
           begin
             sem_err(concat(token_str[ord(tok)],' between clashing types'));
             code_fix(2,1)
           end                                               {Nlogical}
      else if ((tok <> Neq) or (tok <> Nne)) and (sem[sem_top] = 12 )
             then begin
             sem_err(concat(token_str[ord(tok)],' betwen logical types'))
             end;
                      {Nstring}
     if sem[sem_top] = 20       then code[codeptr] := ord(stri)
                                else code[codeptr] := ord(inti);
     codeptr := codeptr + 1;
     sem_top := sem_top - 1;
     sem[sem_top] := 12 {Nlogical}
    end; { de relation }

       Procedure code_fix {(popcount,pushcount:integer)} ;
{       ************************************************************
        *                                                          *
        *                       code_fix                           *
        *                                                          *
        ************************************************************

    Este procedimiento genera codigo para los valores de pop y push en el stack
    del run_time . Esto es como una respuesta a un error de compilacion
                                                                              }
    Var
       i : integer;

    begin
         for i := 1 to popcount do
           begin
             code[codeptr] := 48 {SSpop};
             codeptr := codeptr + 1
           end;
         for i := 1 to pushcount do
           begin
             code[codeptr] := 24;  {SSpush}
             code[codeptr + 1] :=  1 ;
             codeptr := codeptr + 2
           end
    end;   { de code_fix }

        Procedure bin_op(typ:token; instr:instructions);
{       ************************************************************
        *                                                          *
        *                       bin_op                             *
        *                                                          *
        ************************************************************

    typ   : tipo de operacion
    instr : instruccion
                                                                              }
    Var
       L,M : integer ;
    Begin
      L := ord(typ); M := ord(instr);
      if (sem[sem_top] <> L ) or (sem[sem_top - 1] <> L )
        then
         begin
           sem_err(concat(instr_str[ M ],' operation on non-',
                   token_str[ L ]));
           code_fix(2,1);
           sem[sem_top - 1] := L
         end
        else
         begin
           code[codeptr] := M ;
           codeptr := codeptr + 1
         end;
      sem_top := sem_top - 1
    end;  { de bin_op }

        Procedure split(instr:instructions);
{       ************************************************************
        *                                                          *
        *                       split                              *
        *                                                          *
        ************************************************************
                                                                              }
    begin
         if sem[sem_top] <> 12 {Nlogical} then
            begin
            sem_err(concat(instr_str[ord(instr)],' operation on non-logical'));
              code_fix(1,1)
            end;
         code[codeptr] := ord(instr);
         sem[sem_top] := codeptr + 1;
         codeptr := codeptr + 2
    end;  { de split }

        Procedure unary_op(typ:token; instr:instructions);
{       ************************************************************
        *                                                          *
        *                       unary_op                           *
        *                                                          *
        ************************************************************
                                                                              }
    Var
       L : integer;
    Begin
      L := ord(typ);
      if sem[sem_top] <> L then
        begin
    sem_err(concat(instr_str[ord(instr)],' operation on non-',token_str[ L ]));
         code_fix(1,1);
         sem[sem_top] := L
        end
        else
          begin
            code[codeptr] := ord(instr) ;
            codeptr := codeptr + 1
          end;
    end;  { unary_op }

     Procedure format_lit;
{       *************************************************************
        *                                                           *
        *                       format_lit                          *
        *                                                           *
        *************************************************************
                                                                              }
    Label case_in,case_out,fin_format_lit;
    Var
       t,len,top,bottom,digit,value,c : integer;
       fchar,nchar                  : char;
       int : boolean;
    begin
         { localiza los argumentos }
     top := sem_top;
     while sem[sem_top] <> -1 do
           sem_top := sem_top - 1;
     code[codeptr]:= 55;  {SSwrite}
     code[codeptr + 1] := top - sem_top;
     codeptr := codeptr + 2;
     bottom := sem_top + 1;
     sem_top := sem_top - 1;
             { examinando la literal }
     t := 0;
{     writeln('*',strbuf,'*') { borrar ; }
     len := length(strbuf);
     while t < len do
           begin
             { obtiene el formato de un caracter }
             fchar := ' ';
             while fchar = ' ' do
                   begin
                     t := t + 1;
                     if t > len then fchar := ','
                                else
                                 begin
                                   fchar := copy(strbuf,t,1);
                                   if fchar = ',' then
                                      begin
                                        sem_err('extra format comma');
                                        fchar:= ' '
                                      end;
                                end;
                   end;
             { remueve blancos  }
             nchar := ' ';
             while nchar = ' ' do
                   begin
                     t := t + 1;
                     if t > len then nchar := ','
                                else nchar := copy(strbuf,t,1)
                   end;
             { checa para enteros }
             int := false;
             value := 0;
             while ('0' <= nchar) and (nchar <= '9') do
                   begin
                     int := true;
                     { GET STRING (nchar) EDIT (digit) (F(1)) }
                     val(nchar,digit,c);
                     value := value * 10 + digit ;
                     t := t + 1;
                     if t > len  then nchar := ','
                                 else nchar := copy(strbuf,t,1);
                   end;
             { remueve blancos }
             while nchar = ' ' do
                   begin
                    t := t + 1;
                    if   t > len  then nchar := ','
                                  else nchar := copy(strbuf,t,1);
                   end;
             { checa por un comma }
              if nchar <> ',' then
                 begin
                   sem_err('missing format comma');
                   t := t - 1
                 end;
{ etiqueta }  case_in :
              { item entero }
              if fchar = 'i' then
                   begin
                        if bottom > top then
                                      begin
                                        sem_err('extra format item(s)');
                                        goto fin_format_lit
                                      end;
                        if sem[bottom] <> 11 {Ninteger} then
                           begin
                             sem_err('wrong format item');
                             if sem[bottom] = 20 {Nstring} then fchar := 's'
                                                      else fchar := 'l';
                             goto case_in
                           end;
                         code[codeptr] := 56;  {SSwriteint}
                         code[codeptr + 1] := value;
                         codeptr := codeptr + 2;
                         bottom := bottom + 1;
                         goto case_out
                   end;
              { item string }
              if fchar = 's' then
                 begin
                   if bottom > top then
                             begin
                               sem_err('extra format item(s)');
                               goto fin_format_lit
                             end;
                   if sem[bottom] <> 20 { Nstring } then
                      begin
                        sem_err('wrong format item');
                        if sem[bottom] = 11 { Ninteger} then fchar := 'i'
                                                  else fchar := 'l';
                        goto case_in
                      end;
                    code[codeptr] := 58 ;  {SSwritestr}
                    code[codeptr + 1] := value;
                    codeptr := codeptr + 2;
                    bottom := bottom + 1;
                    goto case_out
                  end;
              { logical item }
              if fchar = 'l' then
                 begin
                   if bottom > top then
                      begin
                        sem_err('extra format item(s)');
                        goto fin_format_lit
                      end;
                   if sem[bottom] <> 12 { Nlogical } then
                       begin
                         sem_err('wrong format item');
                         if sem[bottom] = 11 { Ninteger } then fchar := 'i'
                                                          else fchar := 's';
                         goto case_in
                       end;
                   code[codeptr] := 57;  {SSwritelog}
                   codeptr := codeptr + 1;
                   if int then sem_err('unexpected format integer');
                   bottom := bottom + 1;
                   goto case_out
                 end;
              { space item }
              if fchar = 'x' then
                 begin
                   code[codeptr] := 59; {SSspace}
                   if int then code[codeptr + 1] := value
                          else begin
                                 sem_err('missing format integer');
                                 code[codeptr + 1] := 1
                               end;
                   codeptr := codeptr + 2;
                   goto case_out
                 end;
              { tab item }
              if fchar = 't' then
                 begin
                   code[codeptr] := 60; {SStab}
                   if int then code[codeptr + 1] := value
                      else begin
                             sem_err('missing format integer');
                             code[codeptr + 1] := 1;
                           end;
                   codeptr := codeptr + 2;
                   goto case_out
                 end;
              { newline item }
              if fchar = 'n' then
                 begin
                   code[codeptr] := 16; {SSnewline}
                   codeptr := codeptr + 1;
                   if int then sem_err('extra format integer');
                   goto case_out
                 end;
              { default item }
              if fchar <> ',' then sem_err('illegal format item');
{ etiqueta }  case_out:
           end;
     if bottom <= top
        then
         begin
          sem_err('missing format item(s)');
          code[codeptr] := 59;  {SSspace}
          code[codeptr + 1] := 1;
          codeptr := codeptr + 2;
          while bottom < top do
                begin
                  if sem[bottom] = 11  {Ninteger} then
                     begin
                       code[codeptr] := 56; {SSwriteint}
                       code[codeptr + 1] := 0;
                       codeptr := codeptr + 2;
                     end
                    else
                     if sem[bottom] = 20  {Nstring} then
                        begin
                          code[codeptr] := 58; {SSwritestr}
                          code[codeptr + 1] := 0;
                          codeptr := codeptr + 2
                        end
                       else
                        begin
                          code[codeptr] := 57;  {SSwritelog}
                          codeptr := codeptr + 1
                        end;
                  code[codeptr] := 59; {SSspace}
                  code[codeptr + 1] := 1;
                  codeptr := codeptr + 2;
                  bottom := bottom + 1
                end
         end;
    fin_format_lit :
    end; { de format_lit }
