{------------------------- RESINT.PAS  -----------------------------------}

    Begin   { comienza next_instruction }
          flg := false;        { tambien como bandera auxiliar }
          if int_debug then
             begin writeln; writeln;
                   writeln('Next instruction location: ',ic:3)
             end;
          { checa si la siguiente instruction no puede ser ejecutada }
          if (ic >= codeptr) or (ic < 1) then
             begin
               error('out of code area',1); flg := true
             end;
          if not flg then
             if (code[ic] < 1) or (code[ic] >= codeptr) then
                begin
                  error('illegal instruction',1); flg := true
                end;
          if not flg then
            begin
             if int_debug then
                begin
                  writeln('Instruction is: ',instr_str[code[ic]]);
                  for i := ic + 1 to ic + num_ops[code[ic]] do
                           write(code[i]:8);
                  writeln;writeln('Stack pointer: ',sp:5)
                end;
             if (sp < 0) or (sp + 5 > nsize) then
                     begin
                       error('run-time stack area over(under)flow',1);
                       flg := true
                     end
            end;
(*          writeln('code[ic]->',code[ic]:5,'  ic->',ic:5);    *)
          if not flg then
            case operation_code(code[ic]) of

              op1: { absolute - pone la direccion absoluta de el identificador
                                en el tope del stack}
                   begin
                     sp := sp + 1;
                     rs[assign_rs(sp)] := find(code[ic+1]);
                     if scope = 'g' then
                        rs[assign_rs(sp)] := -rs[assign_rs(sp)];
                     ic := ic + 2;
                   end;

              op2:  { add - la suma de los dos elementos en el tope del stack
                            run-time es puesto sobre el stack }
                   begin
                     rs[assign_rs(sp -1)] := run_stack(sp-1) + run_stack(sp);
                     sp := sp - 1;
                     ic := ic + 1
                   end;

              op3 : { allocate - es asignado espacio para un arreglo dinamico }

                   begin
                     rs[assign_rs(find(code[ic+1]))] := find(code[ic+2]);
                     rs[assign_rs(find(code[ic+1])+1)] :=
                                          run_stack(find(code[ic+2])) + sp + 1;
                     n := run_stack(find(code[ic+2]) + 2 +
                          3 * (run_stack(find(code[ic+2])+1) - 1) );
                     for i := sp + 1 to sp + n  do
                         rs[i] := 0;
                     sp := sp + n;
                     ic := ic + 3;
                   end;

              op4 : { concat - un descriptor de las cadenas concatenadas es
                      puesto en el tope del stack                          }
                   begin
              str := concat(stringf(run_stack(sp - 1)),stringf(run_stack(sp)));
                     { free operands  }
                     if run_stack(sp-1) > 0 then
                 string_area[run_stack(sp-1)] := -string_area[run_stack(sp-1)];
                     rs[assign_rs(sp-1)] := descriptor(str);
                     sp := sp - 1;
                     ic := ic + 1
                   end;
              op5 : { deref - la direccion absoluta del elemento del arreglo es
                      puesta en el tope del stack                             }
                    begin
                      p := find(code[ic + 1]); flg := false;
                      if scope = 'l'
                         then
                           begin
                             t := run_stack(find(code[ic+1]));
                             n := run_stack(t + 1);
                             ctr := run_stack(find(code[ic+1]) + 1);
                             for i := 1 to n do
                              if (run_stack(sp-n+i) < run_stack(t+3*(i-1)+3))or
                                 (run_stack(sp-n+i) > run_stack(t+3*(i-1)+4))
                                 then begin
                                error('dimension for array is out-of-bounds',1);
                                      flg := true    { regresa }
                                      end
                                 else if i <> 1
                                       then
                                        ctr := ctr + run_stack(sp-n+i) *
                                                     run_stack(t+3*(i-2)+2)
                                       else ctr := ctr + run_stack(sp - n + i);
                             if not flg then
                                begin
                                   sp := sp - (n -1);
                                   rs[assign_rs(sp)] := ctr
                                end
                           end
                         else
                           begin
                             t := global[globall(find(code[ic + 1]))];
                             n := global[globall(t + 1)];
                             ctr := global[globall(find(code[ic+1]) + 1)];
                             for i := 1 to n  do
                              if
                             (run_stack(sp-n+i)<global[globall(t+3*(i-1)+3)])or
                             (run_stack(sp-n+i)>global[globall(t+3*(i-1)+4)])
                               then begin
                                error('dimension for array is out-of-bounds',1);
                                      flg := true    { regresa }
                                      end
                               else
                                 if i <> 1
                                  then
                                    ctr := ctr + run_stack(sp-n+i) *
                                           global[globall(t+3*(i-2)+2)]
                                  else
                                    ctr := ctr + run_stack(sp -n + i);
                             if not flg then
                                begin
                                  sp := sp - (n - 1);
                                  rs[assign_rs(sp)] := -ctr
                                end
                           end;
                      if not flg then
                         ic := ic + 2
                    end;

              op6 :  { derefi (indirect dereference) - la direccion absoluta de
                        el elemento del arreglo es puesta en el tope del stack}
                    begin
                      flg := false;
                      if run_stack(find(code[ic + 1])) > 0
                       then
                         begin
                           t := run_stack(run_stack(find(code[ic+1])));
                           n := run_stack(t + 1);
                           ctr:= run_stack(run_stack(find(code[ic+1]))+1);
                           for i := 1 to n do
                              if (run_stack(sp-n+i) < run_stack(t+3*(i-1)+3))or
                                 (run_stack(sp-n+i) > run_stack(t+3*(i-1)+4))
                                 then begin
                               error('dimension for array is out-of-bounds',1);
                                      flg := true    { regresa }
                                      end
                                 else if i <> 1
                                       then
                                        ctr := ctr + run_stack(sp-n+i) *
                                                     run_stack(t+3*(i-2)+2)
                                       else ctr := ctr + run_stack(sp - n + i);
                             if not flg then
                                begin
                                   sp := sp - (n -1);
                                   rs[assign_rs(sp)] := ctr
                                end
                           end
                         else
                           begin
                         t := global[globall(-run_stack(find(code[ic+1])))];
                             n := global[globall(t + 1)];
                         ctr:=global[globall(-run_stack(find(code[ic+1]))+1)];
                             for i := 1 to n  do
                              if
                             (run_stack(sp-n+i)<global[globall(t+3*(i-1)+3)])or
                             (run_stack(sp-n+i)>global[globall(t+3*(i-1)+4)])
                               then begin
                               error('dimension for array is out-of-bounds',1);
                                      flg := true    { regresa }
                                      end
                               else
                                 if i <> 1
                                  then
                                    ctr := ctr + run_stack(sp-n+i) *
                                           global[globall(t+3*(i-2)+2)]
                                  else
                                    ctr := ctr + run_stack(sp -n + i);
                             if not flg then
                                begin
                                  sp := sp - (n - 1);
                                  rs[assign_rs(sp)] := -ctr
                                end
                           end;
                      if not flg then
                         ic := ic + 2
                    end;

              op7 : {  divide - el cociente es puesto en el tope del stack}
                    begin
                      flg := false;
                      if run_stack(sp) = 0 then
                         begin
                           error('attemp to divide by zero',1);
                           flg := true
                         end;
                      if not flg then
                        begin
                      rs[assign_rs(sp-1)] := run_stack(sp-1) div run_stack(sp);
                          ic := ic +1 ;
                          sp := sp - 1
                        end
                    end;

              op8 :  { dump - vacia el contenido de las localidades de memoria
                             apropiadas }
                    begin
                      dump;
                      ic := ic + 1
                    end;

              op9 :  { ieq - el valor de verdad de la relacion = es puesto en
                             el tope del satck  }
                    begin
                      if run_stack(sp-1) = run_stack(sp)
                         then rs[assign_rs(sp -1)] := 1
                         else rs[assign_rs(sp -1)] := 0;
                      sp := sp -1;
                      ic := ic +1
                    end;

              op10:  { ige -  el valor de verdad de la relacion >= es puesto en
                             el tope del satck  }
                    begin
                      if run_stack(sp-1) >= run_stack(sp)
                         then rs[assign_rs(sp -1)] := 1
                         else rs[assign_rs(sp -1)] := 0;
                      sp := sp -1;
                      ic := ic +1
                    end;

              op11:  { igt - el valor de verdad de la relacion > es puesto en
                             el tope del satck  }
                    begin
                      if run_stack(sp-1) > run_stack(sp)
                         then rs[assign_rs(sp -1)] := 1
                         else rs[assign_rs(sp -1)] := 0;
                      sp := sp -1;
                      ic := ic +1
                    end;

              op12:  { ile - el valor de verdad de la relacion <= es puesto en
                             el tope del satck  }
                    begin
                      if run_stack(sp-1) <= run_stack(sp)
                         then rs[assign_rs(sp -1)] := 1
                         else rs[assign_rs(sp -1)] := 0;
                      sp := sp -1;
                      ic := ic +1
                    end;

              op13:  { ilt - el valor de verdad de la relacion < es puesto en
                             el tope del satck  }
                    begin
                      if run_stack(sp-1) < run_stack(sp)
                         then rs[assign_rs(sp -1)] := 1
                         else rs[assign_rs(sp -1)] := 0;
                      sp := sp -1;
                      ic := ic +1
                    end;

              op14:  { ine - el valor de verdad de la relacion <> es puesto en
                             el tope del satck  }
                    begin
                      if run_stack(sp-1) <> run_stack(sp)
                         then rs[assign_rs(sp -1)] := 1
                         else rs[assign_rs(sp -1)] := 0;
                      sp := sp -1;
                      ic := ic +1
                    end;

              op15:  { index - el indice de la configuracion de la cadena es
                               puesto en el tope del stack }
                    begin
                      t := pos(stringf(run_stack(sp)),stringf(run_stack(sp-1)));
                      if run_stack(sp) > 0 then
                       string_area[run_stack(sp)]:=-string_area[run_stack(sp)];
                      if run_stack(sp-1) > 0 then
                   string_area[run_stack(sp-1)]:=-string_area[run_stack(sp-1)];
                      rs[assign_rs(sp-1)] := t;
                      sp := sp - 1;
                      ic := ic + 1
                    end;

              op16:  { newline - el dispositivo de salida avanza una nueva
                                 linea }
                    begin
                      writeln;
                      ic := ic + 1
                    end;

              op17:  { jump - el control es transferido a otro procedimiento:
                              el apuntador a la base del registro de activa-
                              cion y el pointer instruction son inicializados }
                    begin
                      abp := sp - code[ic + 2] -1;
                      if (abp < 1) or (abp > sp) then
                         error('activation base pointer out of stack area',1);
                         ic := code[ic + 1];
                    end;

              op18:  { readlog - un valor es leido en la variable booleana }
                   begin
                     scan_over; flg := false;
      (*               if eof1 or real_eof then
                        begin
                          error('attempt to read past end of file',1);
                          flg := true
                        end;                        *)
                    if not flg then
                     if length(input_stream) >= 1
                       then
                        if  (copy(input_stream,1,1) <> 'true') and
                            (copy(input_stream,1,1) <> 'TRUE') and
                            (copy(input_stream,1,1) <> 'false') and
                            (copy(input_stream,1,1) <> 'FALSE')
                          then
                           begin
              error('invalid data type in input, boolean constant expected',1);
                             flg := true
                           end
                          else delay(0)
                       else if length(input_stream) >= 4
                               then if copy(input_stream,1,4) <> 'true'
                                       then
                                        begin
              error('invalid data type in input, boolean constant expected',1);
                                         flg := true
                                        end;
                    if not flg then
                     if copy(input_stream,1,4) <> 'true'
                       then
                        begin
                         if run_stack(sp) > 0
                            then rs[assign_rs(run_stack(sp))] := 1
                            else global[globall(-run_stack(sp))] := 1;
                         if length(input_stream) > 4
                            then input_stream := copy(input_stream,5,
                                                        length(input_stream))
                            else input_stream := ''
                        end
                       else
                        begin
                         if run_stack(sp) > 0
                            then rs[assign_rs(run_stack(sp))] := 0
                            else global[globall(-run_stack(sp))] := 0;
                         if length(input_stream) > 5
                            then input_stream := copy(input_stream,6,
                                                        length(input_stream))
                            else input_stream := ''
                        end;
(*                   if not flg then
                     if copy(input_stream,1,4) = 'true'
                        then if length(input_stream) > 4
                                then input_stream := copy(input_stream,5,
                                                        length(input_stream))
                                else read(input_stream)
                        else if length(input_stream) > 5
                                then input_stream := copy(input_stream,6,
                                                        length(input_stream))
                                else read(input_stream);                   *)
                    if not flg then
                       begin
                         sp := sp -1;
                         ic := ic +1
                       end;
                     input_stream := '';
                   end;
              op19:  { load - el valor de la variable es puesto en el stack }
                   begin
                     sp := sp + 1;
                     t := find(code[ic+1]);
                     if scope = 'g'
                        then rs[assign_rs(sp)] := global[globall(t)]
                        else rs[assign_rs(sp)] := run_stack(t);
                     ic := ic + 2
                   end;

              op20:  { loadi (load indirect) - el valor de la variable es
                                               puesto en el stack      }
                   begin
                     sp := sp + 1;
                     t := find(code[ic+1]);
                     if run_stack(t) > 0
                      then rs[assign_rs(sp)] := run_stack(run_stack(t))
                      else rs[assign_rs(sp)] := global[globall(-run_stack(t))];
                     ic := ic + 2;
                   end;

              op21:  { line - el numero de linea es salvado en el contador de
                              lineas                                        }
                   begin
                     line_number := code[ic + 1];
                     ic := ic + 2
                   end;

              op22:  { multiply - el producto es puesto en el tope del stack }
                   begin
                     rs[assign_rs(sp-1)] := run_stack(sp-1) * run_stack(sp);
                     ic := ic + 1;
                     sp := sp - 1
                   end;

              op23:  { negate - la negacion aritmetica es puesta en el tope
                                del stack                                  }
                   begin
                     rs[assign_rs(sp)] := - run_stack(sp);
                     ic := ic + 1
                   end;

              op24:  { push - el valor es puesto en el tope del stack }
                   begin
                     sp := sp + 1;
                     rs[assign_rs(sp)] := code[ic + 1];
                     ic := ic + 2;
                   end;

              op25:  { loada (load absolute) - el valor de la variable
                                               es puesta en el stack  }
                   begin
                    if run_stack(sp) > 0
                     then rs[assign_rs(sp)] := run_stack(run_stack(sp))
                     else rs[assign_rs(sp)] := global[globall(-run_stack(sp))];
                    ic := ic + 1
                    end;

              op26:  { rem (remainder on division) - el residuo de la division
                                         es puesto en el tope del stack }
                    begin
                      flg := false;
                      if run_stack(sp) = 0 then
                         begin
                           error('division by zero',1);
                           flg := true
                         end;
                      if not flg then
                         begin
                     rs[assign_rs(sp-1)] := run_stack(sp-1) mod run_stack(sp);
                           sp := sp - 1;
                           ic := ic + 1
                         end;
                    end;

              op27:  { seq  (string relation) - el valor de verdad de la rela-
                            cion string = es puesto en el tope del stack      }
                    begin
                      if stringf(run_stack(sp-1)) = stringf(run_stack(sp))
                         then i := 1
                         else i := 0;

                      { free operands }
                      if run_stack(sp-1) > 0 then
                         string_area[run_stack(sp-1)] :=
                                                 -string_area[run_stack(sp-1)];
                      if run_stack(sp) > 0 then
                         string_area[run_stack(sp)] :=
                                                   -string_area[run_stack(sp)];
                      rs[assign_rs(sp-1)] := i;
                      sp := sp -1;
                      ic := ic + 1
                    end;

              op28:  { sge  (string relation) - el valor de verdad de la rela-
                            cion string >= es puesto en el tope del stack     }
                    begin
                      if stringf(run_stack(sp-1)) >= stringf(run_stack(sp))
                         then i := 1
                         else i := 0;

                      { free operands }
                      if run_stack(sp-1) > 0 then
                         string_area[run_stack(sp-1)] :=
                                                 -string_area[run_stack(sp-1)];
                      if run_stack(sp) > 0 then
                         string_area[run_stack(sp)] :=
                                                   -string_area[run_stack(sp)];
                      rs[assign_rs(sp-1)] := i;
                      sp := sp -1;
                      ic := ic + 1
                    end;

              op29:  { sgt  (string relation) - el valor de verdad de la rela-
                            cion string > es puesto en el tope del stack     }
                    begin
                      if stringf(run_stack(sp-1)) > stringf(run_stack(sp))
                         then i := 1
                         else i := 0;

                      { free operands }
                      if run_stack(sp-1) > 0 then
                         string_area[run_stack(sp-1)] :=
                                                 -string_area[run_stack(sp-1)];
                      if run_stack(sp) > 0 then
                         string_area[run_stack(sp)] :=
                                                   -string_area[run_stack(sp)];
                      rs[assign_rs(sp-1)] := i;
                      sp := sp -1;
                      ic := ic + 1
                    end;

              op30:  { sle  (string relation) - el valor de verdad de la rela-
                            cion string <= es puesto en el tope del stack     }
                    begin
                      if stringf(run_stack(sp-1)) <= stringf(run_stack(sp))
                         then i := 1
                         else i := 0;

                      { free operands }
                      if run_stack(sp-1) > 0 then
                         string_area[run_stack(sp-1)] :=
                                                 -string_area[run_stack(sp-1)];
                      if run_stack(sp) > 0 then
                         string_area[run_stack(sp)] :=
                                                   -string_area[run_stack(sp)];
                      rs[assign_rs(sp-1)] := i;
                      sp := sp -1;
                      ic := ic + 1
                    end;

              op31:  { slt  (string relation) - el valor de verdad de la rela-
                            cion string < es puesto en el tope del stack     }
                    begin
                      if stringf(run_stack(sp-1)) < stringf(run_stack(sp))
                         then i := 1
                         else i := 0;

                      { free operands }
                      if run_stack(sp-1) > 0 then
                         string_area[run_stack(sp-1)] :=
                                                 -string_area[run_stack(sp-1)];
                      if run_stack(sp) > 0 then
                         string_area[run_stack(sp)] :=
                                                   -string_area[run_stack(sp)];
                      rs[assign_rs(sp-1)] := i;
                      sp := sp -1;
                      ic := ic + 1
                    end;

              op32:  { sne  (string relation) - el valor de verdad de la rela-
                            cion string < es puesto en el tope del stack     }
                    begin
                      inline($cc);
                      if stringf(run_stack(sp-1)) <> stringf(run_stack(sp))
                         then i := 1
                         else i := 0;

                      { free operands }
                      if run_stack(sp-1) > 0 then
                         string_area[run_stack(sp-1)] :=
                                                 -string_area[run_stack(sp-1)];
                      if run_stack(sp) > 0 then
                         string_area[run_stack(sp)] :=
                                                   -string_area[run_stack(sp)];
                      rs[assign_rs(sp-1)] := i;
                      sp := sp -1;
                      ic := ic + 1
                    end;

              op33:  { store - es asignado un valor a la variable  }
                    begin
                      t := find(code[ic + 1]);
                      if scope = 'l'
                         then rs[assign_rs(t)] := run_stack(sp)
                         else global[globall(t)] := run_stack(sp);
                      sp := sp - 1;
                      ic := ic + 2
                    end;

              op34:  { storei (store indirect) - es asignado un valor a la
                                                 variable  }
                    begin
                      t := find(code[ic + 1]);
                      if run_stack(t) > 0
                         then rs[assign_rs(run_stack(t))] := run_stack(sp)
                         else global[globall(-run_stack(t))] := run_stack(sp);
                      sp := sp - 1;
                      ic := ic + 1
                    end;

              op35:  { subtract - la diferencia es puesta en el tope del
                                  stack }
                    begin
                      rs[assign_rs(sp -1)] := run_stack(sp-1) - run_stack(sp);
                      sp := sp -1;
                      ic := ic + 1
                    end;

              op36:  { substring - el descriptor de la substring ( desde la
                                   posicion de curso hasta el fin de la string)
                                   es puesto en el tope del satck }
                    begin
                      if run_stack(sp) < 1
                         then chars := stringf(run_stack(sp-1))
                         else if run_stack(sp) >
                                               length(stringf(run_stack(sp-1)))
                               then chars := ''
                               else chars := copy(stringf(run_stack(sp-1)),
                                              run_stack(sp),
                                             length(stringf(run_stack(sp-1))));
                      if run_stack(sp-1) > 0 then
                   string_area[run_stack(sp-1)]:=-string_area[run_stack(sp-1)];
                      rs[assign_rs(sp-1)] := descriptor(chars);
                      sp := sp -1;
                      ic := ic + 1
                    end;

