                          { scanner.pas }

 Function scanner:token;
{       ************************************************************
        *                                                          *
        *                       SCANNER                            *
        *                                                          *
        ************************************************************

        El SCANNER es utilizado para regresar los tokens al parser. Cada vez -
        que este es llamado, regresara el siguiente token. El scanner trabaja
        usando el primer caracter leido para encontrar la clase de token a la
        que pertenece. Esto se logra utilizando la tabla que se describe abajo.
        Enseguida el scanner procesa el resto del token, de acuerdo a su clase.
        Despues el token es regresado ( un numero ) a la rutina que lo llamo.
                                                                              }
 Const
                                                                              {
         La siguiente tabla es utilizada para mapear los caracteres regresados
         por la rutina "get_char" . Por ejemplo si el caracter regresado es
         una coma, su valor entero (107 o 6B hex) es usado como un indice a
         esta tabla. El entero que es encontrado en esta localidad (14 en este
         caso ) representa el estado al que el scanner debe ir con este ca -
         racter como el primer caracter del token que esta siendo explorado.
         La localidad 0 indica un caracter ilegal.
                                                                              }

       char_class : array [0..255] of integer =
                  (1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
                   1,1,2,1,22,19,8,15,7,1,4,10,9,5,14,12,1,13,23,23,23,23,23,
                   23,23,23,23,23,18,11,3,21,17,1,20,16,16,16,16,16,16,16,16,
                   16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,1,1,1,
                   1,16,1,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,
                   16,16,16,16,16,16,16,16,16,1,6,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
                   1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
                   1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
                   1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
                   1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1);
 Type
    states = (state0,state1,state2,state3,state4,state5,state6,state7,state8,
              state9,state10,state11,state12,state13,state14,state15,state16,
              state17,state18,state19,state20,state21,state22,state23,state24);
 Var
   class : integer;               { clase del caracter           }
   idbuf : string[idlen];      { mantiene los identificadores }
   char_int:integer;           { Rep. int. del caracter       }
   i,z   : integer;            { temporales                   }
   token1 : token;             { token regresado              }
   out,strloop : boolean;      { esta variable fue agregada   }

    Function verify(line:linea;caracter:char):integer;
{       ************************************************************
        *                                                          *
        *                         verify                           *
        *                                                          *
        ************************************************************
                                                                              }
    Var
       k:integer;
       ver: boolean;

    begin
         verify := 0;
         ver := true;
         for k:= 1 to length(line) do
             if (caracter <> line[k]) and ver then
               begin
                  verify := k;
                  ver := false
               end;
    end;    { de verify  }

   Function get_char:char;

{       ************************************************************
        *                                                          *
        *                       get_char                           *
        *                                                          *
        ************************************************************

        El procedimiento get_char regresa el siguiente caracter del flujo de
        la entrada. La entrada es leida en lineas de 80 caracteres a la vez.
        Antes de que se lea la siguiente linea, un mensaje de error del estatu-
        to anterior es impreso, si es que hay alguno. Despues es leida la si-
        guiente linea y es imprimida si la bandera list_flag es "true".
        Si la linea leida tiene el estatuto "?OPTION" entonces la rutina opcion
        es llamada para recoger la opcion desde la linea  y poner las banderas
        apropiadas. Si un estatuto "?PROGRAM" es leido, entonces un fin falso
        es regresado para indicar el fin del programa anterior. Cuando todos
        los programas se han leido, entonces el "real_eof" es puesto a true, y
        el fin del archivo es regresado. Un caracter "?" es utilizado como un
        fin archivo
                                                                              }
    Var
       i   : integer;          { indice  a line_buf }
       dummy_flag : boolean;

   Procedure option;
{       ************************************************************
        *                                                          *
        *                         option                           *
        *                                                          *
        ************************************************************

        La rutina option recogera las opciones de la linea que contiene el co-
        mando "?OPTION" pone las banderas apropiadas
                                                                              }


   Var
      flag : char;         { El signo "+" o "-" }
      enable,flg : boolean ;   { Enciende o Apaga opt. }
      name   : string[15]; { Nombre de la opcion   }
   Begin
        line_buf := copy(line_buf,8,length(line_buf));
        line_ptr := verify(line_buf,' ');
        while  line_ptr <> 0  do
              begin
                flg := true ;
                line_buf := copy(line_buf,line_ptr ,length(line_buf));
                flag := copy(line_buf,1,1);
                if flag = '+'
                   then begin
                          enable := true;
                          line_buf := copy(line_buf,2,length(line_buf))
                        end
                   else if flag = '-'
                           then begin
                                 enable := false;
                                 line_buf := copy(line_buf,2,length(line_buf));
                                end
                           else enable := true;

                { aisla la opcion que sera puesta }
                begin_tok := 80 - length(line_buf) + 1;
                line_ptr := pos(' ',line_buf);
                if (line_ptr = 0) and (length(line_buf) = 0) then
                   begin
                     if flg then
                        begin
                          error(9,0,0,0);
                          name := '';
                          flg := false
                        end
                   end
                    else
                      if line_ptr = 0
                         then begin
                               name := line_buf;
                               line_buf:= ''
                              end
                         else begin
                               name := copy(line_buf,1,pos(' ',line_buf)-1);
                   line_buf:= copy(line_buf,pos(' ',line_buf),length(line_buf))
                              end;

                { ahora pone la bandera apropiada }

                if name = 'list'
                   then list_flag := enable
                   else if name = 'xref'
                     then xref_flag := enable
                     else if name = 'scanner_debug'
                       then scanner_debug := enable
                       else if name = 'll1_debug'
                         then ll1_debug := enable
                         else if name = 'code_debug'
                           then code_debug := enable
                           else if name = 'sym_debug'
                             then sym_debug := enable
                             else if name = 'int_debug'
                               then int_debug := enable
                               else error(10,0,0,0);

                line_ptr := verify(line_buf,' ');
              end;
        if line_errors > 0 then
                           list_err;
        get_line
   end;              { de option }

                         { comienza  get_char }
    Begin
(* El siguiente bloque se eliminara por la razon de que el programa no se
   ejecutara en batch si en forma interactiva                            *)

(*       if EOF (fte) then           { del archivo de entrada }
                         begin
                              real_eof := true;
                              line_buf := '?program'
                         end;                                            *)
         if new_line then
            begin
                 if ( line_errors > 0 ) then  list_err;
                 get_line
            end;
         if line_ptr = 0 then
            begin
                 dummy_flag := false;
                 while ( copy(line_buf,1,7) = '?option' ) do
                       option ;
                 if ( copy(line_buf,1,8) = '?program' ) or
                    ( copy(line_buf,1,5) = '?data' )  then
                                                   begin
                                                     eof1 := true;
                                                     dummy_flag := true;
                                                     get_char := ' ';
                                                    end;
            end;
         if not dummy_flag then
            begin
              i := verify(copy(line_buf,line_ptr+1,length(line_buf)),' ');
              if i = 1 then
                 begin
                   line_ptr := line_ptr + 1;
                   get_char := copy(line_buf,line_ptr,1)
                 end
               else if i = 0 then
                       begin
                         new_line := true;
                         get_char := ' '
                       end
                     else
                        begin
                          line_ptr := line_ptr + i - 1;
                          get_char := ' '
                        end
            end
   end;            { de get_char     }

   Function get_num:integer;
{       ************************************************************
        *                                                          *
        *                         get_num                          *
        *                                                          *
        ************************************************************

        El procedimiento get_num lee un numero y lo convierte de su formato ca-
        racter a su formato numerico. Si el numero es muy grande para conver --
        tirlo, un mensaje de error es impreso, asi pues el numero mayor permi -
        tido es utilizado (32767).
                                                                              }
   Var
     code : integer;                  { variable de apoyo         }
     number : real ;                  { numero que sera regresado }
     digit  : integer;                { digito convertido         }
     flag_overflow: boolean;          { bandera  de apoyo         }

   Begin
        number := 0;
        flag_overflow := false;
        while (next_char >= '0' ) and  ( next_char <= '9' ) and
              not flag_overflow do
           begin
                val(next_char,digit,code);
                number := number * 10 + digit;
                if number >= 32767
                   then
                     begin
                       flag_overflow := true;
                       error(5,0,0,0)
                     end
                   else next_char := get_char;
           end;
        if flag_overflow
           then
             begin
               while (next_char >= '0') and (next_char <= '9') do
                     next_char:= get_char;
               get_num := 32767
             end
           else get_num := trunc(number)
   end;               { de get_num   }

   Function is_kywd(stringx : string40):integer;
{       ************************************************************
        *                                                          *
        *                         is_kywd                          *
        *                                                          *
        ************************************************************

        A este procedimiento se le da una cadena de caracteres y decide si es o
        no una palabra reservada. Esto es hecho utilizando una busqueda binaria
        en la lista de palabras reservadas "token_str". Si la cadena es una pa-
        labra reservada, el valor del token de la palabra reservada es simple -
        mente su indice en el vector. El valor es regresado, en caso de que la
        cadena no sea una palabra reservada, un valor cero (0) es regresado.
                                                                              }
   Var
{     stringx : string[40];      {  Cadena dada                               }
      first   : integer;         { Apuntador al primer elemento de la Busqueda}
      last    : integer;         { apuntador al ultimo elemento de la Busqueda}
      found   : boolean;
   Begin
        found:= false;
        first := 1;
        last := N_of_keywords;
        while (first <= last) and not found do
              begin
                   i := (first + last) div 2;
                   if (stringx < token_str[i]) then last:= i - 1
                   else if (stringx > token_str[i]) then first:= i + 1
                                                    else
                                                    found:= true;
              end;
        if found then is_kywd := i
                 else is_kywd := 0;
   end;            { fin de is_kywd }

             { comienza procedimiento scanner }
 begin
      out := false;
      repeat
            if eof1 then
                       begin
                            token1 := Neof;
                            out := true
                       end;
            if not out then
                       begin
                            char_int := ord(next_char);
                            class := char_class[char_int];
                            begin_tok := line_ptr
                       end
                       else class:=24;
            case states(class) of
                 state1 :  { caracter no conocido }
                         begin
                           error(1,0,0,0);
                           next_char := get_char
                         end;

                 state2 :  { un caracter blanco (espacio) }
                         next_char := get_char;

                 state3 :  { un signo menor que ( < )  }
                         begin
                           next_char:= get_char;
                           if next_char = '>' then
                                         begin
                                              token1:= Nne;
                                              next_char:= get_char
                                         end
                                     else
                                         if next_char = '=' then
                                            begin
                                                 token1:=Nle;
                                                 next_char := get_char
                                            end
                                           else token1:= Nlt;
                           out:= true
                         end;
                 state4 :   { un parentesis izquierdo }
                         begin
                           token1:= Nlparen;
                           next_char:= get_char;
                           out := true
                         end;
                 state5 :  { un signo mas ( + ) }
                         begin
                           token1:= Nplus;
                           next_char:=get_char;
                           out := true
                         end;
                 state6 :  { operador de substring ( | ) }
                         begin
                           token1 := Nsubstr;
                           next_char := get_char;
                           out := true
                         end;
                 state7 :  { un operador de concatenacion ( & ) }
                         begin
                           token1 := Nconcat;
                           next_char := get_char;
                           out := true
                         end;
                 state8 :  { un delimitador de comentario  }
                         begin
                           next_char := get_char;
                           if next_char <> '$' then error(2,0,0,0);
                           while not new_line do  { end of line }
                                 next_char:= get_char;
                           next_char:=get_char
                         end;
                 state9 :  { operador de multiplicacion }
                         begin
                           token1 := Nmult;
                           next_char := get_char;
                           out := true
                         end;
                 state10:  { parentesis derecho }
                         begin
                           token1:= Nrparen;
                           next_char := get_char;
                           out := true
                         end;
                 state11:  { un punto y coma ( ; ) }
                         begin
                           token1:= Nsemi;
                           next_char:= get_char;
                           out := true
                         end;
                 state12:  { un signo menos (-)  } { checar el token siguiente}
                         begin
                           if (next_token = Nrparen) or
                              (next_token = Nsimpconident) or
                              (next_token = Nsimpident) or
                              (next_token = Nprocident)
                           then token1 := Nminus
                           else token1 := Numinus;
                           next_char := get_char;
                           out := true
                         end;
                 state13:  { un signo de division }
                         begin
                           token1 := Ndiv;
                           next_char:=get_char;
                           out := true
                         end;
                 state14:  { una comma }
                         begin
                           token1:= Ncomma;
                           next_char:=get_char;
                           out:=true
                         end;
                 state15:  { un operador mod (%)  }
                         begin
                           token1:= Nmod;
                           next_char:=get_char;
                           out:= true
                         end;
                 state16:  { un caracter alfabetico }
                         begin
                           idbuf:='';
                           while (class = 16) or (class = 23) do
                                begin
                                  if ( length(idbuf) < idlen ) then
                                               idbuf:= concat(idbuf,next_char);
                                  next_char := get_char;
                                  char_int := ord(next_char);
                                  class:= char_class[char_int]
                                end;
                           token1 := token(is_kywd(idbuf));
                           if token1 = token(0) then
                                        begin
                                             idptr:= lookup(idbuf);
                                             token1:= symtab[idptr].use
                                        end;
                           out:=true
                         end;
                 state17:  { un signo mayor que  ( > )  }
                          begin
                            next_char:=get_char;
                            if next_char = '=' then
                                                  begin
                                                    token1:= Nge;
                                                    next_char:= get_char
                                                  end
                                               else  token1:= Ngt;
                            out:=true
                          end;
                 state18:  { un dos puntos ( : ) }
                          begin
                            next_char := get_char;
                            if next_char = '=' then
                                                 begin
                                                   token1:= Nassign;
                                                   next_char:= get_char
                                                 end
                                               else token1:= Ncolon;
                            out:= true
                          end;
                 state19:  { un operador de longitud de string  ( # ) }
                          begin
                            token1:= Nlength;
                            next_char:= get_char;
                            out:= true
                          end;
                 state20:  { un operador de indice de string ( @ )  }
                          begin
                            token1:= Nindex;
                            next_char:=get_char;
                            out:=true
                          end;
                 state21:  {  un signo igual  }
                          begin
                            token1:= Neq;
                            next_char:=get_char;
                            out:=true
                          end;
                 state22:  { unas comillas ( " ) }
                          begin
                            strbuf := '';
                            z := 0;
                            next_char:= get_char;
                            repeat
                              strloop:=true;
                              while (next_char <> '"')  and not new_line do
                                    begin
                                      if z < strlen then
                                             strbuf:= concat(strbuf,next_char);
                                      z := z + 1;
                                      next_char:= get_char;
                                    end;
                              if new_line then error(4,0,0,0)
                                 else
                                     begin
                                       next_char := get_char;
                                       if next_char = '"'then
                                          begin
                                            if  z < strlen then
                                                    strbuf:=concat(strbuf,' ');
                                            z := z + 1;
                                            next_char:= get_char;
                                            strloop := false
                                          end;
                                     end;
                            until strloop ;
                            if z > strlen then error(3,0,0,0);
                            token1:= Nliteral;
                            out:=true
                          end;
                 state23 :  {  un numero  }
                          begin
                            value := get_num;
                            token1 := Nnumber;
                            out := true
                          end;
            end;     { del case  }
            until out;   { imprime el token para depuracion }
            if scanner_debug then
               begin
              write('    token <',ord(token1),',',token_str[ord(token1)],' >');
                 if token1 = Nnumber then writeln(value);
                 if token1 = Nliteral then  writeln(strbuf);
                 if (token1 = Nnewident) or (token1 = Nsimpident) or
                     (token1 = Nsimpconident) or (token1 = Narrayident) or
                     (token1 = Narrayconident) or (token1 = Nprocident)
                     then write(idbuf) ; writeln('    ');
               end; (*read ;*)
            scanner:= token1
 end;        { termina SCANNER                 }
